{ Parsed from Accounts.framework (iPhoneOS6.0) ACAccountStore.h }
{ Created on Wed Sep 12 7:26:23 2012 }


{$ifdef TYPES}
type
  ACAccountStorePtr = ^ACAccountStore;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  ACFacebookAppIdKey: NSString; cvar; external;
  ACFacebookPermissionsKey: NSString; cvar; external;
  ACFacebookPermissionGroupKey: NSString; cvar; external;
  ACFacebookAppVersionKey: NSString; cvar; external;
  ACFacebookPermissionGroupRead: NSString; cvar; external;
  ACFacebookPermissionGroupWrite: NSString; cvar; external;
  ACFacebookPermissionGroupReadWrite: NSString; cvar; external;
{$endif}

{$ifdef TYPES}
type
  ACAccountCredentialRenewResult = NSInteger;
  ACAccountCredentialRenewResultPtr = ^ACAccountCredentialRenewResult;

const
  ACAccountCredentialRenewResultRenewed = 0;
  ACAccountCredentialRenewResultRejected = 1;
  ACAccountCredentialRenewResultFailed = 2;

type
  ACAccountStoreSaveCompletionHandler = OpaqueCBlock;
  ACAccountStoreRequestAccessCompletionHandler = OpaqueCBlock;
  ACAccountStoreCredentialRenewalHandler = OpaqueCBlock;
{$endif}

{$ifdef CLASSES}

type
  ACAccountStore = objcclass external (NSObject)
  public
    function accounts: NSArray; message 'accounts';
    function accountWithIdentifier (identifier: NSString): ACAccount; message 'accountWithIdentifier:';
    function accountTypeWithAccountTypeIdentifier (typeIdentifier: NSString): ACAccountType; message 'accountTypeWithAccountTypeIdentifier:';
    function accountsWithAccountType (accountType: ACAccountType): NSArray; message 'accountsWithAccountType:';
    procedure saveAccount_withCompletionHandler (account: ACAccount; completionHandler: ACAccountStoreSaveCompletionHandler); message 'saveAccount:withCompletionHandler:';
    procedure requestAccessToAccountsWithType_withCompletionHandler (accountType: ACAccountType; handler: ACAccountStoreRequestAccessCompletionHandler); message 'requestAccessToAccountsWithType:withCompletionHandler:'; deprecated 'in NA, NA, 5_0, 6_0';
    procedure requestAccessToAccountsWithType_options_completion (accountType: ACAccountType; options: NSDictionary; completion: ACAccountStoreRequestAccessCompletionHandler); message 'requestAccessToAccountsWithType:options:completion:';
    procedure renewCredentialsForAccount_completion (account: ACAccount; completionHandler: ACAccountStoreCredentialRenewalHandler); message 'renewCredentialsForAccount:completion:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  ACAccountStoreDidChangeNotification: NSString { available in NA, 5_0 }; cvar; external;
{$endif}

