{ Parsed from AVFoundation.framework (iPhoneOS6.0) AVPlayerItem.h }
{ Created on Wed Sep 12 7:27:58 2012 }


{$ifdef TYPES}
type
  AVPlayerItemPtr = ^AVPlayerItem;
  AVPlayerItemAccessLogPtr = ^AVPlayerItemAccessLog;
  AVPlayerItemErrorLogPtr = ^AVPlayerItemErrorLog;
  AVPlayerItemAccessLogEventPtr = ^AVPlayerItemAccessLogEvent;
  AVPlayerItemErrorLogEventPtr = ^AVPlayerItemErrorLogEvent;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  AVPlayerItemTimeJumpedNotification: NSString { available in 10_7, 5_0 }; cvar; external;
  AVPlayerItemDidPlayToEndTimeNotification: NSString { available in 10_7, 4_0 }; cvar; external;
  AVPlayerItemFailedToPlayToEndTimeNotification: NSString { available in 10_7, 4_3 }; cvar; external;
  AVPlayerItemPlaybackStalledNotification: NSString { available in TBD, 6_0 }; cvar; external;
  AVPlayerItemNewAccessLogEntryNotification: NSString { available in TBD, 6_0 }; cvar; external;
  AVPlayerItemNewErrorLogEntryNotification: NSString { available in TBD, 6_0 }; cvar; external;
  AVPlayerItemFailedToPlayToEndTimeErrorKey: NSString { available in 10_7, 4_3 }; cvar; external;
{$endif}

{$ifdef TYPES}
const
  AVPlayerItemStatusUnknown = 0;
  AVPlayerItemStatusReadyToPlay = 1;
  AVPlayerItemStatusFailed = 2;

type
  AVPlayerItemStatus = NSInteger;
  AVPlayerItemStatusPtr = ^AVPlayerItemStatus;
{$endif}

{$ifdef CLASSES}

type
  AVPlayerItem = objcclass external (NSObject, NSCopyingProtocol)
  private
    _playerItem: AVPlayerItemInternal;
  public
    class function playerItemWithURL (URL: NSURL): AVPlayerItem; message 'playerItemWithURL:';
    class function playerItemWithAsset (asset: AVAsset): AVPlayerItem; message 'playerItemWithAsset:';
    function initWithURL (URL: NSURL): id; message 'initWithURL:';
    function initWithAsset (asset: AVAsset): id; message 'initWithAsset:';
    function status: AVPlayerItemStatus; message 'status';
    function error: NSError; message 'error';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
  end;


type
  AVPlayerItemInspection = objccategory external (AVPlayerItem)
    function asset: AVAsset; message 'asset';
    function tracks: NSArray; message 'tracks';
    function duration: CMTime; message 'duration';
    function presentationSize: CGSize; message 'presentationSize';
    function timedMetadata: NSArray; message 'timedMetadata';
  end;

type
  AVPlayerItemRateAndSteppingSupport = objccategory external (AVPlayerItem)
    function canPlayFastForward: boolean; message 'canPlayFastForward';
    function canPlaySlowForward: boolean; message 'canPlaySlowForward';
    function canPlayReverse: boolean; message 'canPlayReverse';
    function canPlaySlowReverse: boolean; message 'canPlaySlowReverse';
    function canPlayFastReverse: boolean; message 'canPlayFastReverse';
    function canStepForward: boolean; message 'canStepForward';
    function canStepBackward: boolean; message 'canStepBackward';
  end;

type
  AVPlayerItemTimeControl = objccategory external (AVPlayerItem)
    function currentTime: CMTime; message 'currentTime';
    procedure setForwardPlaybackEndTime(newValue: CMTime); message 'setForwardPlaybackEndTime:';
    function forwardPlaybackEndTime: CMTime; message 'forwardPlaybackEndTime';
    procedure setReversePlaybackEndTime(newValue: CMTime); message 'setReversePlaybackEndTime:';
    function reversePlaybackEndTime: CMTime; message 'reversePlaybackEndTime';
    function seekableTimeRanges: NSArray; message 'seekableTimeRanges';
    procedure seekToTime (time: CMTime); message 'seekToTime:';
    procedure seekToTime_completionHandler (time: CMTime; completionHandler: OpaqueCBlock); message 'seekToTime:completionHandler:'; { available in 10_7, 5_0 }
    procedure seekToTime_toleranceBefore_toleranceAfter (time: CMTime; toleranceBefore: CMTime; toleranceAfter: CMTime); message 'seekToTime:toleranceBefore:toleranceAfter:';
    procedure seekToTime_toleranceBefore_toleranceAfter_completionHandler (time: CMTime; toleranceBefore: CMTime; toleranceAfter: CMTime; completionHandler: OpaqueCBlock); message 'seekToTime:toleranceBefore:toleranceAfter:completionHandler:'; { available in 10_7, 5_0 }
    procedure cancelPendingSeeks; message 'cancelPendingSeeks'; { available in 10_7, 5_0 }
    function currentDate: NSDate; message 'currentDate';
    function seekToDate (date: NSDate): boolean; message 'seekToDate:';
    function seekToDate_completionHandler (date: NSDate; completionHandler: OpaqueCBlock): boolean; message 'seekToDate:completionHandler:'; { available in TBD, 6_0 }
    procedure stepByCount (stepCount: NSInteger); message 'stepByCount:';
    function timebase: CMTimebaseRef; message 'timebase';
  end;

type
  AVPlayerItemPresentation = objccategory external (AVPlayerItem)
    procedure setAudioMix(newValue: AVAudioMix); message 'setAudioMix:';
    function audioMix: AVAudioMix; message 'audioMix';
    procedure setVideoComposition(newValue: AVVideoComposition); message 'setVideoComposition:';
    function videoComposition: AVVideoComposition; message 'videoComposition';
    procedure setSeekingWaitsForVideoCompositionRendering(newValue: boolean); message 'setSeekingWaitsForVideoCompositionRendering:';
    function seekingWaitsForVideoCompositionRendering: boolean; message 'seekingWaitsForVideoCompositionRendering';
    procedure setTextStyleRules(newValue: NSArray); message 'setTextStyleRules:';
    function textStyleRules: NSArray; message 'textStyleRules';
  end;

type
  AVPlayerItemPlayability = objccategory external (AVPlayerItem)
    function loadedTimeRanges: NSArray; message 'loadedTimeRanges';
    function isPlaybackLikelyToKeepUp: boolean; message 'isPlaybackLikelyToKeepUp';
    function isPlaybackBufferFull: boolean; message 'isPlaybackBufferFull';
    function isPlaybackBufferEmpty: boolean; message 'isPlaybackBufferEmpty';
  end;

type
  AVPlayerItemMediaSelection = objccategory external (AVPlayerItem)
    procedure selectMediaOption_inMediaSelectionGroup (mediaSelectionOption: AVMediaSelectionOption; mediaSelectionGroup: AVMediaSelectionGroup); message 'selectMediaOption:inMediaSelectionGroup:'; { available in 10_8, 5_0 }
    function selectedMediaOptionInMediaSelectionGroup (mediaSelectionGroup: AVMediaSelectionGroup): AVMediaSelectionOption; message 'selectedMediaOptionInMediaSelectionGroup:'; { available in 10_8, 5_0 }
  end;

type
  AVPlayerItemLogging = objccategory external (AVPlayerItem)
    function accessLog: AVPlayerItemAccessLog; message 'accessLog'; { available in 10_7, 4_3 }
    function errorLog: AVPlayerItemErrorLog; message 'errorLog'; { available in 10_7, 4_3 }
  end;

type
  AVPlayerItemOutputs = objccategory external (AVPlayerItem)
    procedure addOutput (output: AVPlayerItemOutput); message 'addOutput:'; { available in 10_8, 6_0 }
    procedure removeOutput (output: AVPlayerItemOutput); message 'removeOutput:'; { available in 10_8, 6_0 }
    function outputs: NSArray; message 'outputs';
  end;


type
  AVPlayerItemAccessLog = objcclass external (NSObject, NSCopyingProtocol)
  private
    _playerItemAccessLog: AVPlayerItemAccessLogInternal;
  public
    function extendedLogData: NSData; message 'extendedLogData';
    function extendedLogDataStringEncoding: NSStringEncoding; message 'extendedLogDataStringEncoding';
    function events: NSArray; message 'events';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
  end;

type
  AVPlayerItemErrorLog = objcclass external (NSObject, NSCopyingProtocol)
  private
    _playerItemErrorLog: AVPlayerItemErrorLogInternal;
  public
    function extendedLogData: NSData; message 'extendedLogData';
    function extendedLogDataStringEncoding: NSStringEncoding; message 'extendedLogDataStringEncoding';
    function events: NSArray; message 'events';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
  end;

type
  AVPlayerItemAccessLogEvent = objcclass external (NSObject, NSCopyingProtocol)
  private
    _playerItemAccessLogEvent: AVPlayerItemAccessLogEventInternal;
  public
    function numberOfSegmentsDownloaded: NSInteger; message 'numberOfSegmentsDownloaded';
    function numberOfMediaRequests: NSInteger; message 'numberOfMediaRequests';
    function playbackStartDate: NSDate; message 'playbackStartDate';
    function URI: NSString; message 'URI';
    function serverAddress: NSString; message 'serverAddress';
    function numberOfServerAddressChanges: NSInteger; message 'numberOfServerAddressChanges';
    function playbackSessionID: NSString; message 'playbackSessionID';
    function playbackStartOffset: NSTimeInterval; message 'playbackStartOffset';
    function segmentsDownloadedDuration: NSTimeInterval; message 'segmentsDownloadedDuration';
    function durationWatched: NSTimeInterval; message 'durationWatched';
    function numberOfStalls: NSInteger; message 'numberOfStalls';
    function numberOfBytesTransferred: clonglong; message 'numberOfBytesTransferred';
    function observedBitrate: double; message 'observedBitrate';
    function indicatedBitrate: double; message 'indicatedBitrate';
    function numberOfDroppedVideoFrames: NSInteger; message 'numberOfDroppedVideoFrames';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
  end;

type
  AVPlayerItemErrorLogEvent = objcclass external (NSObject, NSCopyingProtocol)
  private
    _playerItemErrorLogEvent: AVPlayerItemErrorLogEventInternal;
  public
    function date: NSDate; message 'date';
    function URI: NSString; message 'URI';
    function serverAddress: NSString; message 'serverAddress';
    function playbackSessionID: NSString; message 'playbackSessionID';
    function errorStatusCode: NSInteger; message 'errorStatusCode';
    function errorDomain: NSString; message 'errorDomain';
    function errorComment: NSString; message 'errorComment';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
  end;
{$endif}

