{ Parsed from CoreData.framework (iPhoneOS6.0) NSManagedObjectContext.h }
{ Created on Wed Sep 12 7:28:02 2012 }


{ Types from NSManagedObjectContext }
{$ifdef TYPES}

{$endif}


{$ifdef TYPES}
type
  NSManagedObjectContextPtr = ^NSManagedObjectContext;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSManagedObjectContextWillSaveNotification: NSString { available in 10_5, 3_0 }; cvar; external;
  NSManagedObjectContextDidSaveNotification: NSString { available in 10_4, 3_0 }; cvar; external;
  NSManagedObjectContextObjectsDidChangeNotification: NSString { available in 10_4, 3_0 }; cvar; external;
  NSInsertedObjectsKey: NSString { available in 10_4, 3_0 }; cvar; external;
  NSUpdatedObjectsKey: NSString { available in 10_4, 3_0 }; cvar; external;
  NSDeletedObjectsKey: NSString { available in 10_4, 3_0 }; cvar; external;
  NSRefreshedObjectsKey: NSString { available in 10_5, 3_0 }; cvar; external;
  NSInvalidatedObjectsKey: NSString { available in 10_5, 3_0 }; cvar; external;
  NSInvalidatedAllObjectsKey: NSString { available in 10_5, 3_0 }; cvar; external;
{$endif}

{$ifdef TYPES}
const
  NSConfinementConcurrencyType = $00;
  NSPrivateQueueConcurrencyType = $01;
  NSMainQueueConcurrencyType = $02;

type
  NSManagedObjectContextConcurrencyType = NSUInteger;
  NSManagedObjectContextConcurrencyTypePtr = ^NSManagedObjectContextConcurrencyType;
{$endif}

{$ifdef CLASSES}

type
  NSManagedObjectContext = objcclass external (NSObject, NSCodingProtocol, NSLockingProtocol)
  private
    _spinLock: cint32;
    _parentObjectStore: id;
    _undoManager: NSUndoManager;
    _dispatchQueue: pointer;
    _managedObjectContextFlags: bitpacked record
      case byte of
        0: (_anonBitField__managedObjectContextFlags0: cuint);
        1: (
          _registeredForCallback: 0..1;
          _propagatesDeletesAtEndOfEvent: 0..1;
          _exhaustiveValidation: 0..1;
          _processingChanges: 0..1;
          _useCommittedSnapshot: 0..1;
          _registeredUndoTransactionID: 0..1;
          _retainsAllRegisteredObjects: 0..1;
          _savingInProgress: 0..1;
          _wasDisposed: 0..1;
          _unprocessedChangesPending: 0..1;
          _isDirty: 0..1;
          _ignoreUndoCheckpoints: 0..1;
          _propagatingDeletes: 0..1;
          _isNSEditorEditing: 0..1;
          _isMainThreadBlessed: 0..1;
          _isImportContext: 0..1;
          _preflightSaveInProgress: 0..1;
          _disableDiscardEditing: 0..1;
          _isParentStoreContext: 0..1;
          _postSaveNotifications: 0..1;
          _isMerging: 0..1;
          _reservedFlags: 0..((1 shl 11)-1);
        );
      end;
    _unprocessedChanges: NSMutableSet;
    _unprocessedDeletes: NSMutableSet;
    _unprocessedInserts: NSMutableSet;
    _insertedObjects: NSMutableSet;
    _deletedObjects: NSMutableSet;
    _changedObjects: NSMutableSet;
    _lockedObjects: NSMutableSet;
    _refreshedObjects: NSMutableSet;
    _infoByGID: id;
    _cachedObsInfoByEntity: idPtr;
    _undoTransactionID: cshort;
    _lock: id;
    _lockCount: clong;
    _objectStoreLockCount: clong;
    _fetchTimestamp: NSTimeInterval;
    _delegate: id;
    _referenceQueue: id;
    _userinfo: id;
    _mergePolicy: id;
    _cd_rc: cint32;
    _ignoreChangeNotification: cint32;
    _editors: id;
    _debuggingRecords: idPtr;
    _childObjectStores: id;
    _reserved2: id;
  public
    function initWithConcurrencyType (ct: NSManagedObjectContextConcurrencyType): id; message 'initWithConcurrencyType:'; { available in 10_7,  5_0 }
    {$if defined(NS_BLOCKS_AVAILABLE)}
    procedure performBlock (block: OpaqueCBlock); message 'performBlock:'; { available in 10_7,  5_0 }
    procedure performBlockAndWait (block: OpaqueCBlock); message 'performBlockAndWait:'; { available in 10_7,  5_0 }
    {$endif}
    procedure setPersistentStoreCoordinator (coordinator: NSPersistentStoreCoordinator); message 'setPersistentStoreCoordinator:';
    function persistentStoreCoordinator: NSPersistentStoreCoordinator; message 'persistentStoreCoordinator';
    procedure setParentContext (parent: NSManagedObjectContext); message 'setParentContext:'; { available in 10_7,  5_0 }
    function parentContext: NSManagedObjectContext; message 'parentContext'; { available in 10_7,  5_0 }
    procedure setUndoManager (undoManager: NSUndoManager); message 'setUndoManager:';
    function undoManager: NSUndoManager; message 'undoManager';
    function hasChanges: boolean; message 'hasChanges';
    function userInfo: NSMutableDictionary; message 'userInfo'; { available in 10_7,  5_0 }
    function concurrencyType: NSManagedObjectContextConcurrencyType; message 'concurrencyType'; { available in 10_7,  5_0 }
    function objectRegisteredForID (objectID: NSManagedObjectID): NSManagedObject; message 'objectRegisteredForID:';
    function objectWithID (objectID: NSManagedObjectID): NSManagedObject; message 'objectWithID:';
    function existingObjectWithID_error (objectID: NSManagedObjectID; error: NSErrorPtr): NSManagedObject; message 'existingObjectWithID:error:'; { available in 10_6, 3_0 }
    function executeFetchRequest_error (request: NSFetchRequest; error: NSErrorPtr): NSArray; message 'executeFetchRequest:error:';
    function countForFetchRequest_error (request: NSFetchRequest; error: NSErrorPtr): NSUInteger; message 'countForFetchRequest:error:'; { available in 10_5, 3_0 }
    procedure insertObject (object_: NSManagedObject); message 'insertObject:';
    procedure deleteObject (object_: NSManagedObject); message 'deleteObject:';
    procedure refreshObject_mergeChanges (object_: NSManagedObject; flag: boolean); message 'refreshObject:mergeChanges:';
    procedure detectConflictsForObject (object_: NSManagedObject); message 'detectConflictsForObject:';
    procedure observeValueForKeyPath_ofObject_change_context (keyPath: NSString; object_: id; change: NSDictionary; context: pointer); message 'observeValueForKeyPath:ofObject:change:context:';
    procedure processPendingChanges; message 'processPendingChanges';
    procedure assignObject_toPersistentStore (object_: id; store: NSPersistentStore); message 'assignObject:toPersistentStore:';
    function insertedObjects: NSSet; message 'insertedObjects';
    function updatedObjects: NSSet; message 'updatedObjects';
    function deletedObjects: NSSet; message 'deletedObjects';
    function registeredObjects: NSSet; message 'registeredObjects';
    procedure undo; message 'undo';
    procedure redo; message 'redo';
    procedure reset; message 'reset';
    procedure rollback; message 'rollback';
    function save (error: NSErrorPtr): boolean; message 'save:';
    procedure lock; message 'lock';
    procedure unlock; message 'unlock';
    function tryLock: boolean; message 'tryLock';
    function propagatesDeletesAtEndOfEvent: boolean; message 'propagatesDeletesAtEndOfEvent';
    procedure setPropagatesDeletesAtEndOfEvent (flag: boolean); message 'setPropagatesDeletesAtEndOfEvent:';
    function retainsRegisteredObjects: boolean; message 'retainsRegisteredObjects';
    procedure setRetainsRegisteredObjects (flag: boolean); message 'setRetainsRegisteredObjects:';
    function stalenessInterval: NSTimeInterval; message 'stalenessInterval';
    procedure setStalenessInterval (expiration: NSTimeInterval); message 'setStalenessInterval:';
    procedure setMergePolicy (mergePolicy: id); message 'setMergePolicy:';
    function mergePolicy: id; message 'mergePolicy';
    function obtainPermanentIDsForObjects_error (objects: NSArray; error: NSErrorPtr): boolean; message 'obtainPermanentIDsForObjects:error:'; { available in 10_5, 3_0 }
    procedure mergeChangesFromContextDidSaveNotification (notification: NSNotification); message 'mergeChangesFromContextDidSaveNotification:'; { available in 10_5, 3_0 }

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;
{$endif}

