{ Parsed from Foundation.framework (iPhoneOS6.0) NSCalendar.h }
{ Created on Wed Sep 12 7:28:44 2012 }


{$ifdef TYPES}
type
  NSCalendarPtr = ^NSCalendar;
  NSDateComponentsPtr = ^NSDateComponents;
{$endif}

{$ifdef TYPES}
type
  NSCalendarUnit = NSUInteger;
  NSCalendarUnitPtr = ^NSCalendarUnit;

const
  NSEraCalendarUnit = kCFCalendarUnitEra;
  NSYearCalendarUnit = kCFCalendarUnitYear;
  NSMonthCalendarUnit = kCFCalendarUnitMonth;
  NSDayCalendarUnit = kCFCalendarUnitDay;
  NSHourCalendarUnit = kCFCalendarUnitHour;
  NSMinuteCalendarUnit = kCFCalendarUnitMinute;
  NSSecondCalendarUnit = kCFCalendarUnitSecond;
  NSWeekCalendarUnit = kCFCalendarUnitWeek;
  NSWeekdayCalendarUnit = kCFCalendarUnitWeekday;
  NSWeekdayOrdinalCalendarUnit = kCFCalendarUnitWeekdayOrdinal;
  NSQuarterCalendarUnit = kCFCalendarUnitQuarter { available in 10_6, 4_0 };
  NSWeekOfMonthCalendarUnit = kCFCalendarUnitWeekOfMonth { available in 10_7, 5_0 };
  NSWeekOfYearCalendarUnit = kCFCalendarUnitWeekOfYear { available in 10_7, 5_0 };
  NSYearForWeekOfYearCalendarUnit = kCFCalendarUnitYearForWeekOfYear { available in 10_7, 5_0 };
  NSCalendarCalendarUnit = 1 shl 20 { available in 10_7, 4_0 };
  NSTimeZoneCalendarUnit = 1 shl 21 { available in 10_7, 4_0 };
{$endif}

{$ifdef CLASSES}

type
  NSCalendar = objcclass external (NSObject, NSCopyingProtocol, NSSecureCodingProtocol)
  public
    class function currentCalendar: id; message 'currentCalendar';
    class function autoupdatingCurrentCalendar: id; message 'autoupdatingCurrentCalendar'; { available in 10_5, 2_0 }
    function initWithCalendarIdentifier (ident: NSString): id; message 'initWithCalendarIdentifier:';
    function calendarIdentifier: NSString; message 'calendarIdentifier';
    procedure setLocale (locale: NSLocale); message 'setLocale:';
    function locale: NSLocale; message 'locale';
    procedure setTimeZone (tz: NSTimeZone); message 'setTimeZone:';
    function timeZone: NSTimeZone; message 'timeZone';
    procedure setFirstWeekday (weekday: NSUInteger); message 'setFirstWeekday:';
    function firstWeekday: NSUInteger; message 'firstWeekday';
    procedure setMinimumDaysInFirstWeek (mdw: NSUInteger); message 'setMinimumDaysInFirstWeek:';
    function minimumDaysInFirstWeek: NSUInteger; message 'minimumDaysInFirstWeek';
    function minimumRangeOfUnit (unit_: NSCalendarUnit): NSRange; message 'minimumRangeOfUnit:';
    function maximumRangeOfUnit (unit_: NSCalendarUnit): NSRange; message 'maximumRangeOfUnit:';
    function rangeOfUnit_inUnit_forDate (smaller: NSCalendarUnit; larger: NSCalendarUnit; date: NSDate): NSRange; message 'rangeOfUnit:inUnit:forDate:';
    function ordinalityOfUnit_inUnit_forDate (smaller: NSCalendarUnit; larger: NSCalendarUnit; date: NSDate): NSUInteger; message 'ordinalityOfUnit:inUnit:forDate:';
    function rangeOfUnit_startDate_interval_forDate (unit_: NSCalendarUnit; datep: NSDatePtr; tip: NSTimeIntervalPtr; date: NSDate): boolean; message 'rangeOfUnit:startDate:interval:forDate:'; { available in 10_5, 2_0 }
    function dateFromComponents (comps: NSDateComponents): NSDate; message 'dateFromComponents:';
    function components_fromDate (unitFlags: NSUInteger; date: NSDate): NSDateComponents; message 'components:fromDate:';
    function dateByAddingComponents_toDate_options (comps: NSDateComponents; date: NSDate; opts: NSUInteger): NSDate; message 'dateByAddingComponents:toDate:options:';
    function components_fromDate_toDate_options (unitFlags: NSUInteger; startingDate: NSDate; resultDate: NSDate; opts: NSUInteger): NSDateComponents; message 'components:fromDate:toDate:options:';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    class function supportsSecureCoding: boolean; message 'supportsSecureCoding';
  end;
{$endif}

{$ifdef TYPES}
const
  NSWrapCalendarComponents = kCFCalendarComponentsWrap;
const
  NSUndefinedDateComponent = NSIntegerMax;
{$endif}

{$ifdef CLASSES}

type
  NSDateComponents = objcclass external (NSObject, NSCopyingProtocol, NSSecureCodingProtocol)
  public
    function calendar: NSCalendar; message 'calendar'; { available in 10_7, 4_0 }
    function timeZone: NSTimeZone; message 'timeZone'; { available in 10_7, 4_0 }
    function era: NSInteger; message 'era';
    function year: NSInteger; message 'year';
    function month: NSInteger; message 'month';
    function day: NSInteger; message 'day';
    function hour: NSInteger; message 'hour';
    function minute: NSInteger; message 'minute';
    function second: NSInteger; message 'second';
    function week: NSInteger; message 'week';
    function weekday: NSInteger; message 'weekday';
    function weekdayOrdinal: NSInteger; message 'weekdayOrdinal';
    function quarter: NSInteger; message 'quarter'; { available in 10_6, 4_0 }
    function weekOfMonth: NSInteger; message 'weekOfMonth'; { available in 10_7, 5_0 }
    function weekOfYear: NSInteger; message 'weekOfYear'; { available in 10_7, 5_0 }
    function yearForWeekOfYear: NSInteger; message 'yearForWeekOfYear'; { available in 10_7, 5_0 }
    function isLeapMonth: boolean; message 'isLeapMonth'; { available in 10_8, 6_0 }
    procedure setCalendar (cal: NSCalendar); message 'setCalendar:'; { available in 10_7, 4_0 }
    procedure setTimeZone (tz: NSTimeZone); message 'setTimeZone:'; { available in 10_7, 4_0 }
    procedure setEra (v: NSInteger); message 'setEra:';
    procedure setYear (v: NSInteger); message 'setYear:';
    procedure setMonth (v: NSInteger); message 'setMonth:';
    procedure setDay (v: NSInteger); message 'setDay:';
    procedure setHour (v: NSInteger); message 'setHour:';
    procedure setMinute (v: NSInteger); message 'setMinute:';
    procedure setSecond (v: NSInteger); message 'setSecond:';
    procedure setWeek (v: NSInteger); message 'setWeek:';
    procedure setWeekday (v: NSInteger); message 'setWeekday:';
    procedure setWeekdayOrdinal (v: NSInteger); message 'setWeekdayOrdinal:';
    procedure setQuarter (v: NSInteger); message 'setQuarter:'; { available in 10_6, 4_0 }
    procedure setWeekOfMonth (w: NSInteger); message 'setWeekOfMonth:'; { available in 10_7, 5_0 }
    procedure setWeekOfYear (w: NSInteger); message 'setWeekOfYear:'; { available in 10_7, 5_0 }
    procedure setYearForWeekOfYear (y: NSInteger); message 'setYearForWeekOfYear:'; { available in 10_7, 5_0 }
    procedure setLeapMonth (lm: boolean); message 'setLeapMonth:'; { available in 10_8, 6_0 }
    function date: NSDate; message 'date'; { available in 10_7, 4_0 }

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    class function supportsSecureCoding: boolean; message 'supportsSecureCoding';
  end;
{$endif}

