{ Parsed from Foundation.framework (iPhoneOS6.0) NSDate.h }
{ Created on Wed Sep 12 7:28:44 2012 }


{$ifdef TYPES}
type
  NSDatePtr = ^NSDate;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSSystemClockDidChangeNotification: NSString { available in 10_6, 4_0 }; cvar; external;
{$endif}

{$ifdef TYPES}
type
  NSTimeInterval = double;
  NSTimeIntervalPtr = ^NSTimeInterval;

const
  NSTimeIntervalSince1970 = 978307200.0;
{$endif}

{$ifdef CLASSES}

type
  NSDate = objcclass external (NSObject, NSCopyingProtocol, NSSecureCodingProtocol)
  public
    function timeIntervalSinceReferenceDate: NSTimeInterval; message 'timeIntervalSinceReferenceDate';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    class function supportsSecureCoding: boolean; message 'supportsSecureCoding';
  end;


type
  NSExtendedDate = objccategory external (NSDate)
    function timeIntervalSinceDate (anotherDate: NSDate): NSTimeInterval; message 'timeIntervalSinceDate:';
    function timeIntervalSinceNow: NSTimeInterval; message 'timeIntervalSinceNow';
    function timeIntervalSince1970: NSTimeInterval; message 'timeIntervalSince1970';
    function addTimeInterval (seconds: NSTimeInterval): id; message 'addTimeInterval:'; deprecated 'in 10_0, 10_6, 2_0, 4_0';
    function dateByAddingTimeInterval (ti: NSTimeInterval): id; message 'dateByAddingTimeInterval:'; { available in 10_6, 2_0 }
    function earlierDate (anotherDate: NSDate): NSDate; message 'earlierDate:';
    function laterDate (anotherDate: NSDate): NSDate; message 'laterDate:';
    function compare (other: NSDate): NSComparisonResult; message 'compare:';
    function isEqualToDate (otherDate: NSDate): boolean; message 'isEqualToDate:';
    function description: NSString; message 'description';
    function descriptionWithLocale (locale: id): NSString; message 'descriptionWithLocale:';
    class function timeIntervalSinceReferenceDate: NSTimeInterval; message 'timeIntervalSinceReferenceDate';
  end;

type
  NSDateCreation = objccategory external (NSDate)
    class function date: id; message 'date';
    class function dateWithTimeIntervalSinceNow (secs: NSTimeInterval): id; message 'dateWithTimeIntervalSinceNow:';
    class function dateWithTimeIntervalSinceReferenceDate (secs: NSTimeInterval): id; message 'dateWithTimeIntervalSinceReferenceDate:';
    class function dateWithTimeIntervalSince1970 (secs: NSTimeInterval): id; message 'dateWithTimeIntervalSince1970:';
    class function dateWithTimeInterval_sinceDate (ti: NSTimeInterval; date_: NSDate): id; message 'dateWithTimeInterval:sinceDate:';
    class function distantFuture: id; message 'distantFuture';
    class function distantPast: id; message 'distantPast';
    function init: id; message 'init';
    function initWithTimeIntervalSinceNow (secs: NSTimeInterval): id; message 'initWithTimeIntervalSinceNow:';
    function initWithTimeIntervalSinceReferenceDate (secsToBeAdded: NSTimeInterval): id; message 'initWithTimeIntervalSinceReferenceDate:';
    function initWithTimeIntervalSince1970 (ti: NSTimeInterval): id; message 'initWithTimeIntervalSince1970:';
    function initWithTimeInterval_sinceDate (secsToBeAdded: NSTimeInterval; anotherDate: NSDate): id; message 'initWithTimeInterval:sinceDate:';
  end;
{$endif}

