{ Parsed from Foundation.framework (iPhoneOS6.0) NSFileWrapper.h }
{ Created on Wed Sep 12 7:28:45 2012 }


{$ifdef TYPES}
type
  NSFileWrapperPtr = ^NSFileWrapper;
{$endif}

{$ifdef TYPES}
type
  NSFileWrapperReadingOptions = NSUInteger;
  NSFileWrapperReadingOptionsPtr = ^NSFileWrapperReadingOptions;

const
  NSFileWrapperReadingImmediate = 1 shl 0;
  NSFileWrapperReadingWithoutMapping = 1 shl 1;

type
  NSFileWrapperWritingOptions = NSUInteger;
  NSFileWrapperWritingOptionsPtr = ^NSFileWrapperWritingOptions;

const
  NSFileWrapperWritingAtomic = 1 shl 0;
  NSFileWrapperWritingWithNameUpdating = 1 shl 1;
{$endif}

{$ifdef CLASSES}

type
  NSFileWrapper = objcclass external (NSObject, NSCodingProtocol)
  private
    _fileAttributes: NSDictionary;
    _preferredFileName: NSString;
    _fileName: NSString;
    _contents: id;
    _icon: id;
    _moreVars: id;
  public
    function initWithURL_options_error (url: NSURL; options: NSFileWrapperReadingOptions; outError: NSErrorPtr): id; message 'initWithURL:options:error:'; { available in 10_6, 4_0 }
    function initDirectoryWithFileWrappers (childrenByPreferredName: NSDictionary): id; message 'initDirectoryWithFileWrappers:';
    function initRegularFileWithContents (contents: NSData): id; message 'initRegularFileWithContents:';
    function initSymbolicLinkWithDestinationURL (url: NSURL): id; message 'initSymbolicLinkWithDestinationURL:'; { available in 10_6, 4_0 }
    function initWithSerializedRepresentation (serializeRepresentation: NSData): id; message 'initWithSerializedRepresentation:';
    function isDirectory: boolean; message 'isDirectory';
    function isRegularFile: boolean; message 'isRegularFile';
    function isSymbolicLink: boolean; message 'isSymbolicLink';
    procedure setPreferredFilename (fileName: NSString); message 'setPreferredFilename:';
    function preferredFilename: NSString; message 'preferredFilename';
    procedure setFilename (fileName: NSString); message 'setFilename:';
    function filename: NSString; message 'filename';
    procedure setFileAttributes (fileAttributes: NSDictionary); message 'setFileAttributes:';
    function fileAttributes: NSDictionary; message 'fileAttributes';
    function matchesContentsOfURL (url: NSURL): boolean; message 'matchesContentsOfURL:'; { available in 10_6, 4_0 }
    function readFromURL_options_error (url: NSURL; options: NSFileWrapperReadingOptions; outError: NSErrorPtr): boolean; message 'readFromURL:options:error:'; { available in 10_6, 4_0 }
    function writeToURL_options_originalContentsURL_error (url: NSURL; options: NSFileWrapperWritingOptions; originalContentsURL: NSURL; outError: NSErrorPtr): boolean; message 'writeToURL:options:originalContentsURL:error:'; { available in 10_6, 4_0 }
    function serializedRepresentation: NSData; message 'serializedRepresentation';
    function addFileWrapper (child: NSFileWrapper): NSString; message 'addFileWrapper:';
    function addRegularFileWithContents_preferredFilename (data: NSData; fileName_: NSString): NSString; message 'addRegularFileWithContents:preferredFilename:';
    procedure removeFileWrapper (child: NSFileWrapper); message 'removeFileWrapper:';
    function fileWrappers: NSDictionary; message 'fileWrappers';
    function keyForFileWrapper (child: NSFileWrapper): NSString; message 'keyForFileWrapper:';
    function regularFileContents: NSData; message 'regularFileContents';
    function symbolicLinkDestinationURL: NSURL; message 'symbolicLinkDestinationURL'; { available in 10_6, 4_0 }

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;
{$endif}

{$if (defined(TARGET_OS_MAC) and not (defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
{$ifdef CLASSES}

type
  NSFileWrapper_NSDeprecated = objccategory external name 'NSDeprecated' (NSFileWrapper)
    function initWithPath (path: NSString): id; message 'initWithPath:';
    function initSymbolicLinkWithDestination (path: NSString): id; message 'initSymbolicLinkWithDestination:';
    function needsToBeUpdatedFromPath (path: NSString): boolean; message 'needsToBeUpdatedFromPath:';
    function updateFromPath (path: NSString): boolean; message 'updateFromPath:';
    function writeToFile_atomically_updateFilenames (path: NSString; atomicFlag: boolean; updateFilenamesFlag: boolean): boolean; message 'writeToFile:atomically:updateFilenames:';
    function addFileWithPath (path: NSString): NSString; message 'addFileWithPath:';
    function addSymbolicLinkWithDestination_preferredFilename (path: NSString; filename_: NSString): NSString; message 'addSymbolicLinkWithDestination:preferredFilename:';
    function symbolicLinkDestination: NSString; message 'symbolicLinkDestination';
  end;
{$endif}

{$endif}
