{ Parsed from Foundation.framework (iPhoneOS6.0) NSMetadata.h }
{ Created on Wed Sep 12 7:28:45 2012 }


{$ifdef TYPES}
type
  NSMetadataQueryPtr = ^NSMetadataQuery;
  NSMetadataItemPtr = ^NSMetadataItem;
  NSMetadataQueryAttributeValueTuplePtr = ^NSMetadataQueryAttributeValueTuple;
  NSMetadataQueryResultGroupPtr = ^NSMetadataQueryResultGroup;
  NSMetadataQueryDelegateProtocolPtr = ^NSMetadataQueryDelegateProtocol;
{$endif}

{$ifdef CLASSES}

type
  NSMetadataQuery = objcclass external (NSObject)
  private
    _flags: NSUInteger;
    _interval: NSTimeInterval;
    _private:array[0..10] of id;
    _reserved: pointer;
  public
    function init: id; message 'init';
    function delegate: NSMetadataQueryDelegateProtocol; message 'delegate';
    procedure setDelegate (delegate_: NSMetadataQueryDelegateProtocol); message 'setDelegate:';
    function predicate: NSPredicate; message 'predicate';
    procedure setPredicate (predicate_: NSPredicate); message 'setPredicate:';
    function sortDescriptors: NSArray; message 'sortDescriptors';
    procedure setSortDescriptors (descriptors: NSArray); message 'setSortDescriptors:';
    function valueListAttributes: NSArray; message 'valueListAttributes';
    procedure setValueListAttributes (attrs: NSArray); message 'setValueListAttributes:';
    function groupingAttributes: NSArray; message 'groupingAttributes';
    procedure setGroupingAttributes (attrs: NSArray); message 'setGroupingAttributes:';
    function notificationBatchingInterval: NSTimeInterval; message 'notificationBatchingInterval';
    procedure setNotificationBatchingInterval (ti: NSTimeInterval); message 'setNotificationBatchingInterval:';
    function searchScopes: NSArray; message 'searchScopes';
    procedure setSearchScopes (scopes: NSArray); message 'setSearchScopes:';
    function startQuery: boolean; message 'startQuery';
    procedure stopQuery; message 'stopQuery';
    function isStarted: boolean; message 'isStarted';
    function isGathering: boolean; message 'isGathering';
    function isStopped: boolean; message 'isStopped';
    procedure disableUpdates; message 'disableUpdates';
    procedure enableUpdates; message 'enableUpdates';
    function resultCount: NSUInteger; message 'resultCount';
    function resultAtIndex (idx: NSUInteger): id; message 'resultAtIndex:';
    function results: NSArray; message 'results';
    function indexOfResult (result_: id): NSUInteger; message 'indexOfResult:';
    function valueLists: NSDictionary; message 'valueLists';
    function groupedResults: NSArray; message 'groupedResults';
    function valueOfAttribute_forResultAtIndex (attrName: NSString; idx: NSUInteger): id; message 'valueOfAttribute:forResultAtIndex:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  NSMetadataQueryDelegateProtocol = objcprotocol external name 'NSMetadataQueryDelegate' (NSObjectProtocol)
  optional
    function metadataQuery_replacementObjectForResultObject (query: NSMetadataQuery; result_: NSMetadataItem): id; message 'metadataQuery:replacementObjectForResultObject:';
    function metadataQuery_replacementValueForAttribute_value (query: NSMetadataQuery; attrName: NSString; attrValue: id): id; message 'metadataQuery:replacementValueForAttribute:value:';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSMetadataQueryDidStartGatheringNotification: NSString { available in 10_4, 5_0 }; cvar; external;
  NSMetadataQueryGatheringProgressNotification: NSString { available in 10_4, 5_0 }; cvar; external;
  NSMetadataQueryDidFinishGatheringNotification: NSString { available in 10_4, 5_0 }; cvar; external;
  NSMetadataQueryDidUpdateNotification: NSString { available in 10_4, 5_0 }; cvar; external;
  NSMetadataQueryResultContentRelevanceAttribute: NSString { available in 10_4, 5_0 }; cvar; external;
  NSMetadataQueryUserHomeScope: NSString { available in 10_4 }; cvar; external;
  NSMetadataQueryLocalComputerScope: NSString { available in 10_4 }; cvar; external;
  NSMetadataQueryNetworkScope: NSString { available in 10_4 }; cvar; external;
  NSMetadataQueryUbiquitousDocumentsScope: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataQueryUbiquitousDataScope: NSString { available in 10_7, 5_0 }; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  NSMetadataItem = objcclass external (NSObject)
  private
    _item: id;
    _reserved: pointer;
  public
    function valueForAttribute (key: NSString): id; message 'valueForAttribute:';
    function valuesForAttributes (keys: NSArray): NSDictionary; message 'valuesForAttributes:';
    function attributes: NSArray; message 'attributes';
  end;

type
  NSMetadataQueryAttributeValueTuple = objcclass external (NSObject)
  private
    _attr: id;
    _value: id;
    _count: NSUInteger;
    _reserved: pointer;
  public
    function attribute: NSString; message 'attribute';
    function value: id; message 'value';
    function count: NSUInteger; message 'count';
  end;

type
  NSMetadataQueryResultGroup = objcclass external (NSObject)
  private
    _private:array[0..8] of id;
    _private2:array[0..0] of NSUInteger;
    _reserved: pointer;
  public
    function attribute: NSString; message 'attribute';
    function value: id; message 'value';
    function subgroups: NSArray; message 'subgroups';
    function resultCount: NSUInteger; message 'resultCount';
    function resultAtIndex (idx: NSUInteger): id; message 'resultAtIndex:';
    function results: NSArray; message 'results';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  NSMetadataItemFSNameKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataItemDisplayNameKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataItemURLKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataItemPathKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataItemFSSizeKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataItemFSCreationDateKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataItemFSContentChangeDateKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataItemIsUbiquitousKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataUbiquitousItemHasUnresolvedConflictsKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataUbiquitousItemIsDownloadedKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataUbiquitousItemIsDownloadingKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataUbiquitousItemIsUploadedKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataUbiquitousItemIsUploadingKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataUbiquitousItemPercentDownloadedKey: NSString { available in 10_7, 5_0 }; cvar; external;
  NSMetadataUbiquitousItemPercentUploadedKey: NSString { available in 10_7, 5_0 }; cvar; external;
{$endif}

