{ Parsed from Foundation.framework (iPhoneOS6.0) NSObject.h }
{ Created on Wed Sep 12 7:28:44 2012 }


{ Types from NSDeprecatedMethods }
{$ifdef TYPES}

{$endif}


{$ifdef TYPES}
type
  NSObjectPtr = ^NSObject;
  NSObjectProtocolPtr = ^NSObjectProtocol;
  NSCopyingProtocolPtr = ^NSCopyingProtocol;
  NSMutableCopyingProtocolPtr = ^NSMutableCopyingProtocol;
  NSCodingProtocolPtr = ^NSCodingProtocol;
  NSSecureCodingProtocolPtr = ^NSSecureCodingProtocol;
  NSDiscardableContentProtocolPtr = ^NSDiscardableContentProtocol;
{$endif}

{$ifdef PROTOCOLS}
(*
type
  NSObjectProtocol = objcprotocol external name 'NSObject'
    function isEqual (object_: id): boolean; message 'isEqual:';
    function hash: NSUInteger; message 'hash';
    function superclass: pobjc_class; message 'superclass';
    function class_: pobjc_class; message 'class';
    function self_: id; message 'self';
    function zone: NSZonePtr; message 'zone';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    function isProxy: boolean; message 'isProxy';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function retain: id; message 'retain';
    procedure release; message 'release';
    function autorelease: id; message 'autorelease';
    function retainCount: NSUInteger; message 'retainCount';
    function description: NSString; message 'description';
  optional
    function debugDescription: NSString; message 'debugDescription';
  end;
*)
type
  NSCopyingProtocol = objcprotocol external name 'NSCopying'
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
  end;

type
  NSMutableCopyingProtocol = objcprotocol external name 'NSMutableCopying'
    function mutableCopyWithZone (zone: NSZonePtr): id; message 'mutableCopyWithZone:';
  end;

type
  NSCodingProtocol = objcprotocol external name 'NSCoding'
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;

type
  NSSecureCodingProtocol = objcprotocol external name 'NSSecureCoding' (NSCodingProtocol)
  required
    class function supportsSecureCoding: boolean; message 'supportsSecureCoding';
  end;
{$endif}

{$ifdef CLASSES}
(*
type
  NSObject = objcclass external (NSObjectProtocol)
  private
    isa: pobjc_class;
  public
    class procedure classLoad; message 'load';
    class procedure initialize; message 'initialize';
    function init: id; message 'init';
    class function new_: id; message 'new';
    class function allocWithZone (zone: NSZonePtr): id; message 'allocWithZone:';
    class function alloc: id; message 'alloc';
    procedure dealloc; message 'dealloc';
    procedure finalize; message 'finalize';
    function copy: id; message 'copy';
    function mutableCopy: id; message 'mutableCopy';
    class function classCopyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    class function classMutableCopyWithZone (zone: NSZonePtr): id; message 'mutableCopyWithZone:';
    class function classSuperclass: pobjc_class; message 'superclass';
    class function classClass: pobjc_class; message 'class';
    class function instancesRespondToSelector (aSelector: SEL): boolean; message 'instancesRespondToSelector:';
    class function classConformsToProtocol (protocol_: Protocol): boolean; message 'conformsToProtocol:';
    function methodForSelector (aSelector: SEL): IMP; message 'methodForSelector:';
    class function instanceMethodForSelector (aSelector: SEL): IMP; message 'instanceMethodForSelector:';
    procedure doesNotRecognizeSelector (aSelector: SEL); message 'doesNotRecognizeSelector:';
    function forwardingTargetForSelector (aSelector: SEL): id; message 'forwardingTargetForSelector:'; { available in 10_5, 2_0 }
    procedure forwardInvocation (anInvocation: NSInvocation); message 'forwardInvocation:';
    function methodSignatureForSelector (aSelector: SEL): NSMethodSignature; message 'methodSignatureForSelector:';
    class function instanceMethodSignatureForSelector (aSelector: SEL): NSMethodSignature; message 'instanceMethodSignatureForSelector:';
    function allowsWeakReference: boolean; message 'allowsWeakReference';
    function retainWeakReference: boolean; message 'retainWeakReference';
    class function classDescription: NSString; message 'description';
    class function isSubclassOfClass (aClass: pobjc_class): boolean; message 'isSubclassOfClass:';
    class function resolveClassMethod (sel_: SEL): boolean; message 'resolveClassMethod:'; { available in 10_5, 2_0 }
    class function resolveInstanceMethod (sel_: SEL): boolean; message 'resolveInstanceMethod:'; { available in 10_5, 2_0 }

    { Adopted protocols }
    function autorelease: id; message 'autorelease';
    function class_: pobjc_class; message 'class';
    function conformsToProtocol (aProtocol: Protocol): boolean; message 'conformsToProtocol:';
    function debugDescription: NSString; message 'debugDescription';
    function description: NSString; message 'description';
    function hash: NSUInteger; message 'hash';
    function isEqual (object_: id): boolean; message 'isEqual:';
    function isKindOfClass (aClass: pobjc_class): boolean; message 'isKindOfClass:';
    function isMemberOfClass (aClass: pobjc_class): boolean; message 'isMemberOfClass:';
    function isProxy: boolean; message 'isProxy';
    function performSelector (aSelector: SEL): id; message 'performSelector:';
    function performSelector_withObject (aSelector: SEL; object_: id): id; message 'performSelector:withObject:';
    function performSelector_withObject_withObject (aSelector: SEL; object1: id; object2: id): id; message 'performSelector:withObject:withObject:';
    procedure release; message 'release';
    function respondsToSelector (aSelector: SEL): boolean; message 'respondsToSelector:';
    function retain: id; message 'retain';
    function retainCount: NSUInteger; message 'retainCount';
    function self_: id; message 'self';
    function superclass: pobjc_class; message 'superclass';
    function zone: NSZonePtr; message 'zone';
  end;
*)

type
  NSCoderMethods = objccategory external (NSObject)
    class function version: NSInteger; message 'version';
    class procedure setVersion (aVersion: NSInteger); message 'setVersion:';
    function classForCoder: pobjc_class; message 'classForCoder';
    function replacementObjectForCoder (aCoder: NSCoder): id; message 'replacementObjectForCoder:';
    function awakeAfterUsingCoder (aDecoder: NSCoder): id; message 'awakeAfterUsingCoder:';
  end;
{$endif}

{$if (defined(TARGET_OS_MAC) and not (defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
{$ifdef CLASSES}

type
  NSDeprecatedMethods = objccategory external (NSObject)
  end;
{$endif}

{$endif}
{$ifdef PROTOCOLS}

type
  NSDiscardableContentProtocol = objcprotocol external name 'NSDiscardableContent'
  required
    function beginContentAccess: boolean; message 'beginContentAccess';
    procedure endContentAccess; message 'endContentAccess';
    procedure discardContentIfPossible; message 'discardContentIfPossible';
    function isContentDiscarded: boolean; message 'isContentDiscarded';
  end;
{$endif}

{$ifdef CLASSES}

type
  NSDiscardableContentProxy = objccategory external (NSObject)
    function autoContentAccessingProxy: id; message 'autoContentAccessingProxy'; { available in 10_6, 4_0 }
  end;
{$endif}

{$ifdef FUNCTIONS}
function NSAllocateObject(aClass: pobjc_class; extraBytes: NSUInteger; zone: NSZonePtr): id; cdecl; external;
procedure NSDeallocateObject(object_: id); cdecl; external;
function NSCopyObject(object_: id; extraBytes: NSUInteger; zone: NSZonePtr): id; cdecl; external; deprecated 'in 10_0, 10_8, 2_0, 6_0';
function NSShouldRetainWithZone(anObject: id; requestedZone: NSZonePtr): boolean; cdecl; external;
procedure NSIncrementExtraRefCount(object_: id); cdecl; external;
function NSDecrementExtraRefCountWasZero(object_: id): boolean; cdecl; external;
function NSExtraRefCount(object_: id): NSUInteger; cdecl; external;
{$endif}

