{ Parsed from Foundation.framework (iPhoneOS6.0) NSURL.h }
{ Created on Wed Sep 12 7:28:45 2012 }


{ Types from NSURL }
{$ifdef TYPES}


type
  NSURLBookmarkCreationOptions = NSUInteger;
type
  NSURLBookmarkCreationOptionsPtr = ^NSURLBookmarkCreationOptions;

const
  NSURLBookmarkCreationPreferFileIDResolution = 1 shl 8;
  NSURLBookmarkCreationMinimalBookmark = 1 shl 9;
  NSURLBookmarkCreationSuitableForBookmarkFile = 1 shl 10;
  NSURLBookmarkCreationWithSecurityScope = 1 shl 11 { available in 10_7, NA };
  NSURLBookmarkCreationSecurityScopeAllowOnlyReadAccess = 1 shl 12 { available in 10_7, NA };

type
  NSURLBookmarkResolutionOptions = NSUInteger;
type
  NSURLBookmarkResolutionOptionsPtr = ^NSURLBookmarkResolutionOptions;

const
  NSURLBookmarkResolutionWithoutUI = 1 shl 8;
  NSURLBookmarkResolutionWithoutMounting = 1 shl 9;
  NSURLBookmarkResolutionWithSecurityScope = 1 shl 10 { available in 10_7, NA };

type
  NSURLBookmarkFileCreationOptions = NSUInteger;
type
  NSURLBookmarkFileCreationOptionsPtr = ^NSURLBookmarkFileCreationOptions;
{$endif}


{$ifdef TYPES}
type
  NSURLPtr = ^NSURL;
  NSFileSecurityPtr = ^NSFileSecurity;
{$endif}

{$ifdef CLASSES}

type
  NSURL = objcclass external (NSObject, NSSecureCodingProtocol, NSCopyingProtocol)
  private
    _urlString: NSString;
    _baseURL: NSURL;
    _clients: pointer;
    _reserved: pointer;
  public
    function initWithScheme_host_path (scheme: NSString; host: NSString; path: NSString): id; message 'initWithScheme:host:path:';
    function initFileURLWithPath_isDirectory (path: NSString; isDir: boolean): id; message 'initFileURLWithPath:isDirectory:'; { available in 10_5, 2_0 }
    function initFileURLWithPath (path: NSString): id; message 'initFileURLWithPath:';
    class function fileURLWithPath_isDirectory (path: NSString; isDir: boolean): id; message 'fileURLWithPath:isDirectory:'; { available in 10_5, 2_0 }
    class function fileURLWithPath (path: NSString): id; message 'fileURLWithPath:';
    class function URLWithString (URLString: NSString): id; message 'URLWithString:';
    class function URLWithString_relativeToURL (URLString: NSString; baseURL: NSURL): id; message 'URLWithString:relativeToURL:';
    function absoluteString: NSString; message 'absoluteString';
    function relativeString: NSString; message 'relativeString';
    function baseURL: NSURL; message 'baseURL';
    function absoluteURL: NSURL; message 'absoluteURL';
    function scheme: NSString; message 'scheme';
    function resourceSpecifier: NSString; message 'resourceSpecifier';
    function host: NSString; message 'host';
    function port: NSNumber; message 'port';
    function user: NSString; message 'user';
    function password: NSString; message 'password';
    function path: NSString; message 'path';
    function fragment: NSString; message 'fragment';
    function parameterString: NSString; message 'parameterString';
    function query: NSString; message 'query';
    function relativePath: NSString; message 'relativePath';
    function isFileURL: boolean; message 'isFileURL';
    function standardizedURL: NSURL; message 'standardizedURL';
    function checkResourceIsReachableAndReturnError (error: NSErrorPtr): boolean; message 'checkResourceIsReachableAndReturnError:'; { available in 10_6, 4_0 }
    function isFileReferenceURL: boolean; message 'isFileReferenceURL'; { available in 10_6, 4_0 }
    function fileReferenceURL: NSURL; message 'fileReferenceURL'; { available in 10_6, 4_0 }
    function filePathURL: NSURL; message 'filePathURL'; { available in 10_6, 4_0 }
    function getResourceValue_forKey_error (value: idPtr; key: NSString; error: NSErrorPtr): boolean; message 'getResourceValue:forKey:error:'; { available in 10_6, 4_0 }
    function resourceValuesForKeys_error (keys: NSArray; error: NSErrorPtr): NSDictionary; message 'resourceValuesForKeys:error:'; { available in 10_6, 4_0 }
    function setResourceValue_forKey_error (value: id; key: NSString; error: NSErrorPtr): boolean; message 'setResourceValue:forKey:error:'; { available in 10_6, 4_0 }
    function setResourceValues_error (keyedValues: NSDictionary; error: NSErrorPtr): boolean; message 'setResourceValues:error:'; { available in 10_6, 4_0 }
    function bookmarkDataWithOptions_includingResourceValuesForKeys_relativeToURL_error (options: NSURLBookmarkCreationOptions; keys: NSArray; relativeURL: NSURL; error: NSErrorPtr): NSData; message 'bookmarkDataWithOptions:includingResourceValuesForKeys:relativeToURL:error:'; { available in 10_6, 4_0 }
    function initByResolvingBookmarkData_options_relativeToURL_bookmarkDataIsStale_error (bookmarkData: NSData; options: NSURLBookmarkResolutionOptions; relativeURL: NSURL; isStale: pboolean; error: NSErrorPtr): id; message 'initByResolvingBookmarkData:options:relativeToURL:bookmarkDataIsStale:error:'; { available in 10_6, 4_0 }
    class function URLByResolvingBookmarkData_options_relativeToURL_bookmarkDataIsStale_error (bookmarkData: NSData; options: NSURLBookmarkResolutionOptions; relativeURL: NSURL; isStale: pboolean; error: NSErrorPtr): id; message 'URLByResolvingBookmarkData:options:relativeToURL:bookmarkDataIsStale:error:'; { available in 10_6, 4_0 }
    class function resourceValuesForKeys_fromBookmarkData (keys: NSArray; bookmarkData: NSData): NSDictionary; message 'resourceValuesForKeys:fromBookmarkData:'; { available in 10_6, 4_0 }
    class function writeBookmarkData_toURL_options_error (bookmarkData: NSData; bookmarkFileURL: NSURL; options: NSURLBookmarkFileCreationOptions; error: NSErrorPtr): boolean; message 'writeBookmarkData:toURL:options:error:'; { available in 10_6, 4_0 }
    class function bookmarkDataWithContentsOfURL_error (bookmarkFileURL: NSURL; error: NSErrorPtr): NSData; message 'bookmarkDataWithContentsOfURL:error:'; { available in 10_6, 4_0 }
    function startAccessingSecurityScopedResource: boolean; message 'startAccessingSecurityScopedResource'; { available in 10_7, NA }
    procedure stopAccessingSecurityScopedResource; message 'stopAccessingSecurityScopedResource'; { available in 10_7, NA }

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    class function supportsSecureCoding: boolean; message 'supportsSecureCoding';
  end;


type
  NSURLUtilities = objccategory external (NSString)
    function stringByAddingPercentEscapesUsingEncoding (enc: NSStringEncoding): NSString; message 'stringByAddingPercentEscapesUsingEncoding:';
    function stringByReplacingPercentEscapesUsingEncoding (enc: NSStringEncoding): NSString; message 'stringByReplacingPercentEscapesUsingEncoding:';
  end;

type
  NSURLPathUtilities = objccategory external (NSURL)
    class function fileURLWithPathComponents (components: NSArray): NSURL; message 'fileURLWithPathComponents:'; { available in 10_6, 4_0 }
    function pathComponents: NSArray; message 'pathComponents'; { available in 10_6, 4_0 }
    function lastPathComponent: NSString; message 'lastPathComponent'; { available in 10_6, 4_0 }
    function pathExtension: NSString; message 'pathExtension'; { available in 10_6, 4_0 }
    function URLByAppendingPathComponent (pathComponent: NSString): NSURL; message 'URLByAppendingPathComponent:'; { available in 10_6, 4_0 }
    function URLByAppendingPathComponent_isDirectory (pathComponent: NSString; isDirectory: boolean): NSURL; message 'URLByAppendingPathComponent:isDirectory:'; { available in 10_7, 5_0 }
    function URLByDeletingLastPathComponent: NSURL; message 'URLByDeletingLastPathComponent'; { available in 10_6, 4_0 }
    function URLByAppendingPathExtension (pathExtension_: NSString): NSURL; message 'URLByAppendingPathExtension:'; { available in 10_6, 4_0 }
    function URLByDeletingPathExtension: NSURL; message 'URLByDeletingPathExtension'; { available in 10_6, 4_0 }
    function URLByStandardizingPath: NSURL; message 'URLByStandardizingPath'; { available in 10_6, 4_0 }
    function URLByResolvingSymlinksInPath: NSURL; message 'URLByResolvingSymlinksInPath'; { available in 10_6, 4_0 }
  end;
{$endif}

{$if (defined(TARGET_OS_MAC) or (defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
{$ifdef CLASSES}

type
  NSFileSecurity = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol)

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;
{$endif}

{$endif}

{$if (defined(TARGET_OS_MAC) and not (defined(TARGET_OS_EMBEDDED) or defined(TARGET_OS_IPHONE)))}
{$ifdef CLASSES}

type
  NSURLClient = objccategory external (NSObject)
    procedure URL_resourceDataDidBecomeAvailable (sender: NSURL; newBytes: NSData); message 'URL:resourceDataDidBecomeAvailable:'; deprecated 'in 10_0, 10_4, 2_0, 2_0';
    procedure URLResourceDidFinishLoading (sender: NSURL); message 'URLResourceDidFinishLoading:'; deprecated 'in 10_0, 10_4, 2_0, 2_0';
    procedure URLResourceDidCancelLoading (sender: NSURL); message 'URLResourceDidCancelLoading:'; deprecated 'in 10_0, 10_4, 2_0, 2_0';
    procedure URL_resourceDidFailLoadingWithReason (sender: NSURL; reason: NSString); message 'URL:resourceDidFailLoadingWithReason:'; deprecated 'in 10_0, 10_4, 2_0, 2_0';
  end;

type
  NSURLLoading = objccategory external (NSURL)
    function resourceDataUsingCache (shouldUseCache: boolean): NSData; message 'resourceDataUsingCache:'; deprecated 'in 10_0, 10_4, 2_0, 2_0';
    procedure loadResourceDataNotifyingClient_usingCache (client: id; shouldUseCache: boolean); message 'loadResourceDataNotifyingClient:usingCache:'; deprecated 'in 10_0, 10_4, 2_0, 2_0';
    function propertyForKey (propertyKey: NSString): id; message 'propertyForKey:'; deprecated 'in 10_0, 10_4, 2_0, 2_0';
    function setResourceData (data: NSData): boolean; message 'setResourceData:'; deprecated 'in 10_0, 10_4, 2_0, 2_0';
    function setProperty_forKey (property_: id; propertyKey: NSString): boolean; message 'setProperty:forKey:'; deprecated 'in 10_0, 10_4, 2_0, 2_0';
    function URLHandleUsingCache (shouldUseCache: boolean): NSURLHandlePtr; message 'URLHandleUsingCache:'; deprecated 'in 10_0, 10_4, 2_0, 2_0';
  end;
{$endif}

{$endif}
