{ Parsed from Foundation.framework (iPhoneOS6.0) NSURLCache.h }
{ Created on Wed Sep 12 7:28:45 2012 }


{$ifdef TYPES}
type
  NSCachedURLResponsePtr = ^NSCachedURLResponse;
  NSURLCachePtr = ^NSURLCache;
{$endif}

{$ifdef TYPES}
const
  NSURLCacheStorageAllowed = 0;
  NSURLCacheStorageAllowedInMemoryOnly = 1;
  NSURLCacheStorageNotAllowed = 2;

type
  NSURLCacheStoragePolicy = NSUInteger;
  NSURLCacheStoragePolicyPtr = ^NSURLCacheStoragePolicy;
{$endif}

{$ifdef CLASSES}

type
  NSCachedURLResponse = objcclass external (NSObject, NSCodingProtocol, NSCopyingProtocol)
  private
    _internal: NSCachedURLResponseInternal;
  public
    function initWithResponse_data (response: NSURLResponse; data: NSData): id; message 'initWithResponse:data:';
    function initWithResponse_data_userInfo_storagePolicy (response: NSURLResponse; data: NSData; userInfo: NSDictionary; storagePolicy: NSURLCacheStoragePolicy): id; message 'initWithResponse:data:userInfo:storagePolicy:';
    function response: NSURLResponse; message 'response';
    function data: NSData; message 'data';
    function userInfo: NSDictionary; message 'userInfo';
    function storagePolicy: NSURLCacheStoragePolicy; message 'storagePolicy';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;

type
  NSURLCache = objcclass external (NSObject)
  private
    _internal: NSURLCacheInternal;
  public
    class function sharedURLCache: NSURLCache; message 'sharedURLCache';
    class procedure setSharedURLCache (cache: NSURLCache); message 'setSharedURLCache:';
    function initWithMemoryCapacity_diskCapacity_diskPath (memoryCapacity: NSUInteger; diskCapacity: NSUInteger; path: NSString): id; message 'initWithMemoryCapacity:diskCapacity:diskPath:';
    function cachedResponseForRequest (request: NSURLRequest): NSCachedURLResponse; message 'cachedResponseForRequest:';
    procedure storeCachedResponse_forRequest (cachedResponse: NSCachedURLResponse; request: NSURLRequest); message 'storeCachedResponse:forRequest:';
    procedure removeCachedResponseForRequest (request: NSURLRequest); message 'removeCachedResponseForRequest:';
    procedure removeAllCachedResponses; message 'removeAllCachedResponses';
    function memoryCapacity: NSUInteger; message 'memoryCapacity';
    function diskCapacity: NSUInteger; message 'diskCapacity';
    procedure setMemoryCapacity (memoryCapacity_: NSUInteger); message 'setMemoryCapacity:';
    procedure setDiskCapacity (diskCapacity_: NSUInteger); message 'setDiskCapacity:';
    function currentMemoryUsage: NSUInteger; message 'currentMemoryUsage';
    function currentDiskUsage: NSUInteger; message 'currentDiskUsage';
  end;
{$endif}

