{ Parsed from Foundation.framework (iPhoneOS6.0) NSURLRequest.h }
{ Created on Wed Sep 12 7:28:45 2012 }


{$ifdef TYPES}
type
  NSURLRequestPtr = ^NSURLRequest;
  NSMutableURLRequestPtr = ^NSMutableURLRequest;
{$endif}

{$ifdef TYPES}
const
  NSURLRequestUseProtocolCachePolicy = 0;
  NSURLRequestReloadIgnoringLocalCacheData = 1;
  NSURLRequestReloadIgnoringLocalAndRemoteCacheData = 4;
  NSURLRequestReloadIgnoringCacheData = NSURLRequestReloadIgnoringLocalCacheData;
  NSURLRequestReturnCacheDataElseLoad = 2;
  NSURLRequestReturnCacheDataDontLoad = 3;
  NSURLRequestReloadRevalidatingCacheData = 5;

type
  NSURLRequestCachePolicy = NSUInteger;
  NSURLRequestCachePolicyPtr = ^NSURLRequestCachePolicy;

const
  NSURLNetworkServiceTypeDefault = 0;
  NSURLNetworkServiceTypeVoIP = 1;
  NSURLNetworkServiceTypeVideo = 2;
  NSURLNetworkServiceTypeBackground = 3;
  NSURLNetworkServiceTypeVoice = 4;

type
  NSURLRequestNetworkServiceType = NSUInteger;
  NSURLRequestNetworkServiceTypePtr = ^NSURLRequestNetworkServiceType;
{$endif}

{$ifdef CLASSES}

type
  NSURLRequest = objcclass external (NSObject, NSCodingProtocol, NSCopyingProtocol, NSMutableCopyingProtocol)
  private
    _internal: NSURLRequestInternal;
  public
    class function requestWithURL (URL: NSURL): id; message 'requestWithURL:';
    class function requestWithURL_cachePolicy_timeoutInterval (URL: NSURL; cachePolicy: NSURLRequestCachePolicy; timeoutInterval: NSTimeInterval): id; message 'requestWithURL:cachePolicy:timeoutInterval:';
    function initWithURL (URL: NSURL): id; message 'initWithURL:';
    function initWithURL_cachePolicy_timeoutInterval (URL: NSURL; cachePolicy: NSURLRequestCachePolicy; timeoutInterval: NSTimeInterval): id; message 'initWithURL:cachePolicy:timeoutInterval:';
    function URL: NSURL; message 'URL';
    function cachePolicy: NSURLRequestCachePolicy; message 'cachePolicy';
    function timeoutInterval: NSTimeInterval; message 'timeoutInterval';
    function mainDocumentURL: NSURL; message 'mainDocumentURL';
    function networkServiceType: NSURLRequestNetworkServiceType; message 'networkServiceType'; { available in 10_7, 4_0 }
    function allowsCellularAccess: boolean; message 'allowsCellularAccess'; { available in 10_8, 6_0 }

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    function mutableCopyWithZone (zone: NSZonePtr): id; message 'mutableCopyWithZone:';
  end;

type
  NSMutableURLRequest = objcclass external (NSURLRequest)
  public
    procedure setURL (URL_: NSURL); message 'setURL:';
    procedure setCachePolicy (policy: NSURLRequestCachePolicy); message 'setCachePolicy:';
    procedure setTimeoutInterval (seconds: NSTimeInterval); message 'setTimeoutInterval:';
    procedure setMainDocumentURL (URL_: NSURL); message 'setMainDocumentURL:';
    procedure setNetworkServiceType (networkServiceType_: NSURLRequestNetworkServiceType); message 'setNetworkServiceType:'; { available in 10_7, 4_0 }
    procedure setAllowsCellularAccess (allow: boolean); message 'setAllowsCellularAccess:'; { available in 10_8, 6_0 }
  end;


type
  NSHTTPURLRequest = objccategory external (NSURLRequest)
    function HTTPMethod: NSString; message 'HTTPMethod';
    function allHTTPHeaderFields: NSDictionary; message 'allHTTPHeaderFields';
    function valueForHTTPHeaderField (field: NSString): NSString; message 'valueForHTTPHeaderField:';
    function HTTPBody: NSData; message 'HTTPBody';
    function HTTPBodyStream: NSInputStream; message 'HTTPBodyStream';
    function HTTPShouldHandleCookies: boolean; message 'HTTPShouldHandleCookies';
    function HTTPShouldUsePipelining: boolean; message 'HTTPShouldUsePipelining'; { available in 10_7, 4_0 }
  end;

type
  NSMutableHTTPURLRequest = objccategory external (NSMutableURLRequest)
    procedure setHTTPMethod (method: NSString); message 'setHTTPMethod:';
    procedure setAllHTTPHeaderFields (headerFields: NSDictionary); message 'setAllHTTPHeaderFields:';
    procedure setValue_forHTTPHeaderField (value: NSString; field: NSString); message 'setValue:forHTTPHeaderField:';
    procedure addValue_forHTTPHeaderField (value: NSString; field: NSString); message 'addValue:forHTTPHeaderField:';
    procedure setHTTPBody (data: NSData); message 'setHTTPBody:';
    procedure setHTTPBodyStream (inputStream: NSInputStream); message 'setHTTPBodyStream:';
    procedure setHTTPShouldHandleCookies (should: boolean); message 'setHTTPShouldHandleCookies:';
    procedure setHTTPShouldUsePipelining (shouldUsePipelining: boolean); message 'setHTTPShouldUsePipelining:'; { available in 10_7, 4_0 }
  end;
{$endif}

