{ Parsed from Foundation.framework (iPhoneOS6.0) NSValue.h }
{ Created on Wed Sep 12 7:28:44 2012 }


{$ifdef TYPES}
type
  NSValuePtr = ^NSValue;
  NSNumberPtr = ^NSNumber;
{$endif}

{$ifdef CLASSES}

type
  NSValue = objcclass external (NSObject, NSCopyingProtocol, NSSecureCodingProtocol)
  public
    procedure getValue (value: pointer); message 'getValue:';
    function objCType: PChar; message 'objCType';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
    class function supportsSecureCoding: boolean; message 'supportsSecureCoding';
  end;


type
  NSValueCreation = objccategory external (NSValue)
    function initWithBytes_objCType (value: pointer; type_: PChar): id; message 'initWithBytes:objCType:';
    class function valueWithBytes_objCType (value: pointer; type_: PChar): NSValue; message 'valueWithBytes:objCType:';
    class function value_withObjCType (value: pointer; type_: PChar): NSValue; message 'value:withObjCType:';
  end;

type
  NSValueExtensionMethods = objccategory external (NSValue)
    class function valueWithNonretainedObject (anObject: id): NSValue; message 'valueWithNonretainedObject:';
    function nonretainedObjectValue: id; message 'nonretainedObjectValue';
    class function valueWithPointer (pointer_: pointer): NSValue; message 'valueWithPointer:';
    function pointerValue: pointer; message 'pointerValue';
    function isEqualToValue (value: NSValue): boolean; message 'isEqualToValue:';
  end;


type
  NSNumber = objcclass external (NSValue)
  public
    function charValue: char; message 'charValue';
    function unsignedCharValue: char; message 'unsignedCharValue';
    function shortValue: cshort; message 'shortValue';
    function unsignedShortValue: cushort; message 'unsignedShortValue';
    function intValue: cint; message 'intValue';
    function unsignedIntValue: cuint; message 'unsignedIntValue';
    function longValue: clong; message 'longValue';
    function unsignedLongValue: culong; message 'unsignedLongValue';
    function longLongValue: clonglong; message 'longLongValue';
    function unsignedLongLongValue: culonglong; message 'unsignedLongLongValue';
    function floatValue: single; message 'floatValue';
    function doubleValue: double; message 'doubleValue';
    function boolValue: boolean; message 'boolValue';
    function integerValue: NSInteger; message 'integerValue'; { available in 10_5, 2_0 }
    function unsignedIntegerValue: NSUInteger; message 'unsignedIntegerValue'; { available in 10_5, 2_0 }
    function stringValue: NSString; message 'stringValue';
    function compare (otherNumber: NSNumber): NSComparisonResult; message 'compare:';
    function isEqualToNumber (number: NSNumber): boolean; message 'isEqualToNumber:';
    function descriptionWithLocale (locale: id): NSString; message 'descriptionWithLocale:';
  end;


type
  NSNumberCreation = objccategory external (NSNumber)
    function initWithChar (value: char): id; message 'initWithChar:';
    function initWithUnsignedChar (value: char): id; message 'initWithUnsignedChar:';
    function initWithShort (value: cshort): id; message 'initWithShort:';
    function initWithUnsignedShort (value: cushort): id; message 'initWithUnsignedShort:';
    function initWithInt (value: cint): id; message 'initWithInt:';
    function initWithUnsignedInt (value: cuint): id; message 'initWithUnsignedInt:';
    function initWithLong (value: clong): id; message 'initWithLong:';
    function initWithUnsignedLong (value: culong): id; message 'initWithUnsignedLong:';
    function initWithLongLong (value: clonglong): id; message 'initWithLongLong:';
    function initWithUnsignedLongLong (value: culonglong): id; message 'initWithUnsignedLongLong:';
    function initWithFloat (value: single): id; message 'initWithFloat:';
    function initWithDouble (value: double): id; message 'initWithDouble:';
    function initWithBool (value: boolean): id; message 'initWithBool:';
    function initWithInteger (value: NSInteger): id; message 'initWithInteger:'; { available in 10_5, 2_0 }
    function initWithUnsignedInteger (value: NSUInteger): id; message 'initWithUnsignedInteger:'; { available in 10_5, 2_0 }
    class function numberWithChar (value: char): NSNumber; message 'numberWithChar:';
    class function numberWithUnsignedChar (value: char): NSNumber; message 'numberWithUnsignedChar:';
    class function numberWithShort (value: cshort): NSNumber; message 'numberWithShort:';
    class function numberWithUnsignedShort (value: cushort): NSNumber; message 'numberWithUnsignedShort:';
    class function numberWithInt (value: cint): NSNumber; message 'numberWithInt:';
    class function numberWithUnsignedInt (value: cuint): NSNumber; message 'numberWithUnsignedInt:';
    class function numberWithLong (value: clong): NSNumber; message 'numberWithLong:';
    class function numberWithUnsignedLong (value: culong): NSNumber; message 'numberWithUnsignedLong:';
    class function numberWithLongLong (value: clonglong): NSNumber; message 'numberWithLongLong:';
    class function numberWithUnsignedLongLong (value: culonglong): NSNumber; message 'numberWithUnsignedLongLong:';
    class function numberWithFloat (value: single): NSNumber; message 'numberWithFloat:';
    class function numberWithDouble (value: double): NSNumber; message 'numberWithDouble:';
    class function numberWithBool (value: boolean): NSNumber; message 'numberWithBool:';
    class function numberWithInteger (value: NSInteger): NSNumber; message 'numberWithInteger:'; { available in 10_5, 2_0 }
    class function numberWithUnsignedInteger (value: NSUInteger): NSNumber; message 'numberWithUnsignedInteger:'; { available in 10_5, 2_0 }
  end;
{$endif}

