{ Parsed from GameKit.framework (iPhoneOS6.0) GKChallenge.h }
{ Created on Wed Sep 12 7:28:07 2012 }


{$ifdef TYPES}
type
  GKChallengePtr = ^GKChallenge;
  GKScoreChallengePtr = ^GKScoreChallenge;
  GKAchievementChallengePtr = ^GKAchievementChallenge;
{$endif}

{$ifdef TYPES}
type
  GKChallengeState = NSInteger;
  GKChallengeStatePtr = ^GKChallengeState;

const
  GKChallengeStateInvalid = 0;
  GKChallengeStatePending = 1;
  GKChallengeStateCompleted = 2;
  GKChallengeStateDeclined = 3;
{$endif}

{$ifdef CLASSES}

type
  GKChallenge = objcclass external (NSObject, NSCodingProtocol)
  public
    class procedure loadReceivedChallengesWithCompletionHandler (completionHandler: OpaqueCBlock); message 'loadReceivedChallengesWithCompletionHandler:';
    procedure decline; message 'decline';
    function issuingPlayerID: NSString; message 'issuingPlayerID';
    function receivingPlayerID: NSString; message 'receivingPlayerID';
    function state: GKChallengeState; message 'state';
    function issueDate: NSDate; message 'issueDate';
    function completionDate: NSDate; message 'completionDate';
    function message_: NSString; message 'message';
    function resolveBundleID: NSString; message 'resolveBundleID';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;

type
  GKScoreChallenge = objcclass external (GKChallenge)
  public
    function score: GKScore; message 'score';
  end;

type
  GKAchievementChallenge = objcclass external (GKChallenge)
  public
    function achievement: GKAchievement; message 'achievement';
  end;


type
  GKScore_GKChallenge = objccategory external name 'GKChallenge' (GKScore)
    procedure issueChallengeToPlayers_message (playerIDs: NSArray; message_: NSString); message 'issueChallengeToPlayers:message:'; { available starting in __MAC_NA,__IPHONE_6_0 }
  end;

type
  GKAchievement_GKChallenge = objccategory external name 'GKChallenge' (GKAchievement)
    procedure issueChallengeToPlayers_message (playerIDs: NSArray; message_: NSString); message 'issueChallengeToPlayers:message:'; { available starting in __MAC_NA,__IPHONE_6_0 }
    procedure selectChallengeablePlayerIDs_withCompletionHandler (playerIDs: NSArray; completionHandler: OpaqueCBlock); message 'selectChallengeablePlayerIDs:withCompletionHandler:'; { available starting in __MAC_NA,__IPHONE_6_0 }
  end;
{$endif}

