{ Parsed from GameKit.framework (iPhoneOS6.0) GKMatch.h }
{ Created on Wed Sep 12 7:28:07 2012 }


{$ifdef TYPES}
type
  GKMatchPtr = ^GKMatch;
  GKMatchDelegateProtocolPtr = ^GKMatchDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  GKMatchSendDataReliable = 0;
  GKMatchSendDataUnreliable = 1;

type
  GKMatchSendDataMode = NSInteger;
  GKMatchSendDataModePtr = ^GKMatchSendDataMode;

const
  GKPlayerStateUnknown = 0;
  GKPlayerStateConnected = 1;
  GKPlayerStateDisconnected = 2;

type
  GKPlayerConnectionState = NSInteger;
  GKPlayerConnectionStatePtr = ^GKPlayerConnectionState;
{$endif}

{$ifdef CLASSES}

type
  GKMatch = objcclass external (NSObject)
  private
  public
    function playerIDs: NSArray; message 'playerIDs';
    procedure setDelegate(newValue: GKMatchDelegateProtocol); message 'setDelegate:';
    function delegate: GKMatchDelegateProtocol; message 'delegate';
    function expectedPlayerCount: NSUInteger; message 'expectedPlayerCount';
    function sendData_toPlayers_withDataMode_error (data: NSData; playerIDs_: NSArray; mode: GKMatchSendDataMode; error: NSErrorPtr): boolean; message 'sendData:toPlayers:withDataMode:error:';
    function sendDataToAllPlayers_withDataMode_error (data: NSData; mode: GKMatchSendDataMode; error: NSErrorPtr): boolean; message 'sendDataToAllPlayers:withDataMode:error:';
    procedure disconnect; message 'disconnect';
    function voiceChatWithName (name: NSString): GKVoiceChat; message 'voiceChatWithName:';
    procedure chooseBestHostPlayerWithCompletionHandler (completionHandler: OpaqueCBlock); message 'chooseBestHostPlayerWithCompletionHandler:'; { available starting in __MAC_NA,__IPHONE_6_0 }
    procedure rematchWithCompletionHandler (completionHandler: OpaqueCBlock); message 'rematchWithCompletionHandler:'; { available starting in __MAC_NA,__IPHONE_6_0 }
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  GKMatchDelegateProtocol = objcprotocol external name 'GKMatchDelegate' (NSObjectProtocol)
  required
    procedure match_didReceiveData_fromPlayer (match: GKMatch; data: NSData; playerID: NSString); message 'match:didReceiveData:fromPlayer:';
  optional
    procedure match_player_didChangeState (match: GKMatch; playerID: NSString; state: GKPlayerConnectionState); message 'match:player:didChangeState:';
    procedure match_didFailWithError (match: GKMatch; error: NSError); message 'match:didFailWithError:';
    function match_shouldReinvitePlayer (match: GKMatch; playerID: NSString): boolean; message 'match:shouldReinvitePlayer:';
  end;
{$endif}

