{ Parsed from GameKit.framework (iPhoneOS6.0) GKMatchmaker.h }
{ Created on Wed Sep 12 7:28:07 2012 }


{ Types from GKMatchRequest }
{$ifdef TYPES}

const
  GKInviteeResponseAccepted = 0;
  GKInviteeResponseDeclined = 1;
  GKInviteeResponseFailed = 2;
  GKInviteeResponseIncompatible = 3;
  GKInviteeResponseUnableToConnect = 4;
  GKInviteeResponseNoAnswer = 5;

type
  GKInviteeResponse = NSInteger;
type
  GKInviteeResponsePtr = ^GKInviteeResponse;

const
  GKMatchTypePeerToPeer = 0;
  GKMatchTypeHosted = 1;
  GKMatchTypeTurnBased = 2;

type
  GKMatchType = NSUInteger;
type
  GKMatchTypePtr = ^GKMatchType;
{$endif}


{$ifdef TYPES}
type
  GKMatchRequestPtr = ^GKMatchRequest;
  GKInvitePtr = ^GKInvite;
  GKMatchmakerPtr = ^GKMatchmaker;
{$endif}

{$ifdef CLASSES}

type
  GKMatchRequest = objcclass external (NSObject)
  private
  public
    procedure setMinPlayers(newValue: NSUInteger); message 'setMinPlayers:';
    function minPlayers: NSUInteger; message 'minPlayers';
    procedure setMaxPlayers(newValue: NSUInteger); message 'setMaxPlayers:';
    function maxPlayers: NSUInteger; message 'maxPlayers';
    procedure setPlayerGroup(newValue: NSUInteger); message 'setPlayerGroup:';
    function playerGroup: NSUInteger; message 'playerGroup';
    procedure setPlayerAttributes(newValue: cuint32); message 'setPlayerAttributes:';
    function playerAttributes: cuint32; message 'playerAttributes';
    procedure setPlayersToInvite(newValue: NSArray); message 'setPlayersToInvite:';
    function playersToInvite: NSArray; message 'playersToInvite';
    procedure setInviteMessage(newValue: NSString); message 'setInviteMessage:';
    function inviteMessage: NSString; message 'inviteMessage';
    procedure setDefaultNumberOfPlayers(newValue: NSUInteger); message 'setDefaultNumberOfPlayers:';
    function defaultNumberOfPlayers: NSUInteger; message 'defaultNumberOfPlayers';
    procedure setInviteeResponseHandler(newValue: OpaqueCBlock); message 'setInviteeResponseHandler:';
    function inviteeResponseHandler: OpaqueCBlock; message 'inviteeResponseHandler';
    class function maxPlayersAllowedForMatchOfType (matchType: GKMatchType): NSUInteger; message 'maxPlayersAllowedForMatchOfType:'; { available starting in __MAC_NA,__IPHONE_6_0 }
  end;

type
  GKInvite = objcclass external (NSObject)
  private
  public
    function inviter: NSString; message 'inviter';
    function isHosted: boolean; message 'isHosted';
    function playerGroup: NSUInteger; message 'playerGroup';
    function playerAttributes: cuint32; message 'playerAttributes';
  end;

type
  GKMatchmaker = objcclass external (NSObject)
  private
  public
    class function sharedMatchmaker: GKMatchmaker; message 'sharedMatchmaker';
    procedure setInviteHandler(newValue: OpaqueCBlock); message 'setInviteHandler:';
    function inviteHandler: OpaqueCBlock; message 'inviteHandler';
    procedure matchForInvite_completionHandler (invite: GKInvite; completionHandler: OpaqueCBlock); message 'matchForInvite:completionHandler:'; { available starting in __MAC_NA,__IPHONE_6_0 }
    procedure findMatchForRequest_withCompletionHandler (request: GKMatchRequest; completionHandler: OpaqueCBlock); message 'findMatchForRequest:withCompletionHandler:';
    procedure findPlayersForHostedMatchRequest_withCompletionHandler (request: GKMatchRequest; completionHandler: OpaqueCBlock); message 'findPlayersForHostedMatchRequest:withCompletionHandler:';
    procedure addPlayersToMatch_matchRequest_completionHandler (match: GKMatch; matchRequest: GKMatchRequest; completionHandler: OpaqueCBlock); message 'addPlayersToMatch:matchRequest:completionHandler:';
    procedure cancel; message 'cancel';
    procedure cancelInviteToPlayer (playerID: NSString); message 'cancelInviteToPlayer:'; { available starting in __MAC_10_8,__IPHONE_6_0 }
    procedure finishMatchmakingForMatch (match: GKMatch); message 'finishMatchmakingForMatch:'; { available starting in __MAC_NA,__IPHONE_6_0 }
    procedure queryPlayerGroupActivity_withCompletionHandler (playerGroup: NSUInteger; completionHandler: OpaqueCBlock); message 'queryPlayerGroupActivity:withCompletionHandler:';
    procedure queryActivityWithCompletionHandler (completionHandler: OpaqueCBlock); message 'queryActivityWithCompletionHandler:';
    procedure startBrowsingForNearbyPlayersWithReachableHandler (reachableHandler: OpaqueCBlock); message 'startBrowsingForNearbyPlayersWithReachableHandler:'; { available starting in __MAC_NA,__IPHONE_6_0 }
    procedure stopBrowsingForNearbyPlayers; message 'stopBrowsingForNearbyPlayers'; { available starting in __MAC_NA,__IPHONE_6_0 }
  end;
{$endif}

