{ Parsed from GameKit.framework (iPhoneOS6.0) GKTurnBasedMatch.h }
{ Created on Wed Sep 12 7:28:07 2012 }


{$ifdef TYPES}
type
  GKTurnBasedParticipantPtr = ^GKTurnBasedParticipant;
  GKTurnBasedEventHandlerPtr = ^GKTurnBasedEventHandler;
  GKTurnBasedMatchPtr = ^GKTurnBasedMatch;
  GKTurnBasedEventHandlerDelegateProtocolPtr = ^GKTurnBasedEventHandlerDelegateProtocol;
{$endif}

{$ifdef TYPES}
const
  GKTurnBasedMatchStatusUnknown = 0;
  GKTurnBasedMatchStatusOpen = 1;
  GKTurnBasedMatchStatusEnded = 2;
  GKTurnBasedMatchStatusMatching = 3;

type
  GKTurnBasedMatchStatus = NSInteger;
  GKTurnBasedMatchStatusPtr = ^GKTurnBasedMatchStatus;

const
  GKTurnBasedParticipantStatusUnknown = 0;
  GKTurnBasedParticipantStatusInvited = 1;
  GKTurnBasedParticipantStatusDeclined = 2;
  GKTurnBasedParticipantStatusMatching = 3;
  GKTurnBasedParticipantStatusActive = 4;
  GKTurnBasedParticipantStatusDone = 5;

type
  GKTurnBasedParticipantStatus = NSInteger;
  GKTurnBasedParticipantStatusPtr = ^GKTurnBasedParticipantStatus;

const
  GKTurnBasedMatchOutcomeNone = 0;
  GKTurnBasedMatchOutcomeQuit = 1;
  GKTurnBasedMatchOutcomeWon = 2;
  GKTurnBasedMatchOutcomeLost = 3;
  GKTurnBasedMatchOutcomeTied = 4;
  GKTurnBasedMatchOutcomeTimeExpired = 5;
  GKTurnBasedMatchOutcomeFirst = 6;
  GKTurnBasedMatchOutcomeSecond = 7;
  GKTurnBasedMatchOutcomeThird = 8;
  GKTurnBasedMatchOutcomeFourth = 9;
  GKTurnBasedMatchOutcomeCustomRange = $00FF0000;

type
  GKTurnBasedMatchOutcome = NSInteger;
  GKTurnBasedMatchOutcomePtr = ^GKTurnBasedMatchOutcome;
{$endif}

{$ifdef CLASSES}

type
  GKTurnBasedParticipant = objcclass external (NSObject)
  private
  public
    function playerID: NSString; message 'playerID';
    function lastTurnDate: NSDate; message 'lastTurnDate';
    function timeoutDate: NSDate; message 'timeoutDate';
    function status: GKTurnBasedParticipantStatus; message 'status';
    procedure setMatchOutcome(newValue: GKTurnBasedMatchOutcome); message 'setMatchOutcome:';
    function matchOutcome: GKTurnBasedMatchOutcome; message 'matchOutcome';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  GKTurnBasedEventHandlerDelegateProtocol = objcprotocol external name 'GKTurnBasedEventHandlerDelegate'
  optional
    procedure handleInviteFromGameCenter (playersToInvite: NSArray); message 'handleInviteFromGameCenter:';
    procedure handleTurnEventForMatch_didBecomeActive (match: GKTurnBasedMatch; didBecomeActive: boolean); message 'handleTurnEventForMatch:didBecomeActive:'; { available starting in __MAC_NA,__IPHONE_6_0 }
    procedure handleTurnEventForMatch (match: GKTurnBasedMatch); message 'handleTurnEventForMatch:'; deprecated 'in __MAC_NA,__MAC_NA,__IPHONE_5_0,__IPHONE_6_0';
    procedure handleMatchEnded (match: GKTurnBasedMatch); message 'handleMatchEnded:';
  end;
{$endif}

{$ifdef CLASSES}

type
  GKTurnBasedEventHandler = objcclass external (NSObject)
  private
  public
    class function sharedTurnBasedEventHandler: GKTurnBasedEventHandler; message 'sharedTurnBasedEventHandler';
    procedure setDelegate(newValue: GKTurnBasedEventHandlerDelegateProtocol); message 'setDelegate:';
    function delegate: GKTurnBasedEventHandlerDelegateProtocol; message 'delegate';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  GKTurnTimeoutDefault: NSTimeInterval { available starting in __MAC_NA,__IPHONE_6_0 }; cvar; external;
  GKTurnTimeoutNone: NSTimeInterval { available starting in __MAC_NA,__IPHONE_6_0 }; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  GKTurnBasedMatch = objcclass external (NSObject)
  private
  public
    function matchID: NSString; message 'matchID';
    function creationDate: NSDate; message 'creationDate';
    function participants: NSArray; message 'participants';
    function status: GKTurnBasedMatchStatus; message 'status';
    function currentParticipant: GKTurnBasedParticipant; message 'currentParticipant';
    function matchData: NSData; message 'matchData';
    procedure setMessage(newValue: NSString); message 'setMessage:';
    function message_: NSString; message 'message';
    function matchDataMaximumSize: NSUInteger; message 'matchDataMaximumSize';
    class procedure findMatchForRequest_withCompletionHandler (request: GKMatchRequest; completionHandler: OpaqueCBlock); message 'findMatchForRequest:withCompletionHandler:';
    class procedure loadMatchesWithCompletionHandler (completionHandler: OpaqueCBlock); message 'loadMatchesWithCompletionHandler:';
    class procedure loadMatchWithID_withCompletionHandler (matchID_: NSString; completionHandler: OpaqueCBlock); message 'loadMatchWithID:withCompletionHandler:'; { available starting in __MAC_10_8,__IPHONE_5_0 }
    procedure rematchWithCompletionHandler (completionHandler: OpaqueCBlock); message 'rematchWithCompletionHandler:'; { available starting in __MAC_NA,__IPHONE_6_0 }
    procedure acceptInviteWithCompletionHandler (completionHandler: OpaqueCBlock); message 'acceptInviteWithCompletionHandler:'; { available starting in __MAC_10_8,__IPHONE_5_0 }
    procedure declineInviteWithCompletionHandler (completionHandler: OpaqueCBlock); message 'declineInviteWithCompletionHandler:'; { available starting in __MAC_10_8,__IPHONE_5_0 }
    procedure removeWithCompletionHandler (completionHandler: OpaqueCBlock); message 'removeWithCompletionHandler:';
    procedure loadMatchDataWithCompletionHandler (completionHandler: OpaqueCBlock); message 'loadMatchDataWithCompletionHandler:';
    procedure endTurnWithNextParticipants_turnTimeout_matchData_completionHandler (nextParticipants: NSArray; timeout: NSTimeInterval; matchData_: NSData; completionHandler: OpaqueCBlock); message 'endTurnWithNextParticipants:turnTimeout:matchData:completionHandler:'; { available starting in __MAC_NA,__IPHONE_6_0 }
    procedure endTurnWithNextParticipant_matchData_completionHandler (nextParticipant: GKTurnBasedParticipant; matchData_: NSData; completionHandler: OpaqueCBlock); message 'endTurnWithNextParticipant:matchData:completionHandler:'; deprecated 'in __MAC_NA,__MAC_NA,__IPHONE_5_0,__IPHONE_6_0';
    procedure participantQuitInTurnWithOutcome_nextParticipants_turnTimeout_matchData_completionHandler (matchOutcome: GKTurnBasedMatchOutcome; nextParticipants: NSArray; timeout: NSTimeInterval; matchData_: NSData; completionHandler: OpaqueCBlock); message 'participantQuitInTurnWithOutcome:nextParticipants:turnTimeout:matchData:completionHandler:'; { available starting in __MAC_NA,__IPHONE_6_0 }
    procedure participantQuitInTurnWithOutcome_nextParticipant_matchData_completionHandler (matchOutcome: GKTurnBasedMatchOutcome; nextParticipant: GKTurnBasedParticipant; matchData_: NSData; completionHandler: OpaqueCBlock); message 'participantQuitInTurnWithOutcome:nextParticipant:matchData:completionHandler:'; deprecated 'in __MAC_NA,__MAC_NA,__IPHONE_5_0,__IPHONE_6_0';
    procedure participantQuitOutOfTurnWithOutcome_withCompletionHandler (matchOutcome: GKTurnBasedMatchOutcome; completionHandler: OpaqueCBlock); message 'participantQuitOutOfTurnWithOutcome:withCompletionHandler:';
    procedure endMatchInTurnWithMatchData_completionHandler (matchData_: NSData; completionHandler: OpaqueCBlock); message 'endMatchInTurnWithMatchData:completionHandler:';
    procedure saveCurrentTurnWithMatchData_completionHandler (matchData_: NSData; completionHandler: OpaqueCBlock); message 'saveCurrentTurnWithMatchData:completionHandler:'; { available starting in __MAC_NA,__IPHONE_6_0 }
  end;
{$endif}

