{$ifndef IPHONEALL}
{$error "You must compile with -dIPHONEALL to use IPHONEALL."}
{$endif}

{$ifdef USES}
uses
	CTypes, MacTypes, MacOSXPosix,
  DefinedClassesCoreFoundation, DefinedClassesSecurity, DefinedClassesFoundation, DefinedClassesCoreGraphics, DefinedClassesOpenGLES, DefinedClassesCoreImage, DefinedClassesCoreText, DefinedClassesQuartzCore, DefinedClassesUIKit, DefinedClassesMobileCoreServices, CFNetwork;
{$endif}

{$ifdef LINK}
{$linkframework CoreFoundation}
{$linkframework Security}
{$linkframework Foundation}
{$linkframework CoreGraphics}
{$linkframework OpenGLES}
{$linkframework CoreImage}
{$linkframework CoreText}
{$linkframework QuartzCore}
{$linkframework UIKit}
{$linkframework MobileCoreServices}
{$endif}

{$ifdef INTERFACE}

{$define CGFLOAT_DEFINED}
{$define NSINTEGER_DEFINED}
{$define __MACTYPES__}
{$define _OS_OSTYPES_H}

{$define FRAMEWORK_LOADED_COREFOUNDATION}
{$define FRAMEWORK_LOADED_SECURITY}
{$define FRAMEWORK_LOADED_FOUNDATION}
{$define FRAMEWORK_LOADED_COREGRAPHICS}
{$define FRAMEWORK_LOADED_OPENGLES}
{$define FRAMEWORK_LOADED_COREIMAGE}
{$define FRAMEWORK_LOADED_CORETEXT}
{$define FRAMEWORK_LOADED_QUARTZCORE}
{$define FRAMEWORK_LOADED_UIKIT}
{$define FRAMEWORK_LOADED_MOBILECORESERVICES}

{$include UndefinedTypes.inc}
{$include corefoundation/UndefinedTypes.inc}
{$include security/UndefinedTypes.inc}
{$include foundation/UndefinedTypes.inc}
{$include coregraphics/UndefinedTypes.inc}
{$include opengles/UndefinedTypes.inc}
{$include coreimage/UndefinedTypes.inc}
{$include coretext/UndefinedTypes.inc}
{$include quartzcore/UndefinedTypes.inc}
{$include uikit/UndefinedTypes.inc}
{$include mobilecoreservices/UndefinedTypes.inc}

{$define TYPES}
{$include corefoundation/Sources.inc}
{$include security/Sources.inc}
{$include foundation/Sources.inc}
{$include coregraphics/Sources.inc}
{$include opengles/Sources.inc}
{$include coreimage/Sources.inc}
{$include coretext/Sources.inc}
{$include quartzcore/Sources.inc}
{$include uikit/Sources.inc}
{$include mobilecoreservices/Sources.inc}
{$undef TYPES}

{$define RECORDS}
{$include corefoundation/Sources.inc}
{$include security/Sources.inc}
{$include foundation/Sources.inc}
{$include coregraphics/Sources.inc}
{$include opengles/Sources.inc}
{$include coreimage/Sources.inc}
{$include coretext/Sources.inc}
{$include quartzcore/Sources.inc}
{$include uikit/Sources.inc}
{$include mobilecoreservices/Sources.inc}
{$undef RECORDS}

{$define PROTOCOLS}
{$include corefoundation/Sources.inc}
{$include security/Sources.inc}
{$include foundation/Sources.inc}
{$include coregraphics/Sources.inc}
{$include opengles/Sources.inc}
{$include coreimage/Sources.inc}
{$include coretext/Sources.inc}
{$include quartzcore/Sources.inc}
{$include uikit/Sources.inc}
{$include mobilecoreservices/Sources.inc}
{$undef PROTOCOLS}

{$define CLASSES}
{$include corefoundation/Sources.inc}
{$include security/Sources.inc}
{$include foundation/Sources.inc}
{$include coregraphics/Sources.inc}
{$include opengles/Sources.inc}
{$include coreimage/Sources.inc}
{$include coretext/Sources.inc}
{$include quartzcore/Sources.inc}
{$include uikit/Sources.inc}
{$include mobilecoreservices/Sources.inc}
{$undef CLASSES}

{$define FUNCTIONS}
{$include corefoundation/Sources.inc}
{$include security/Sources.inc}
{$include foundation/Sources.inc}
{$include coregraphics/Sources.inc}
{$include opengles/Sources.inc}
{$include coreimage/Sources.inc}
{$include coretext/Sources.inc}
{$include quartzcore/Sources.inc}
{$include uikit/Sources.inc}
{$include mobilecoreservices/Sources.inc}
{$undef FUNCTIONS}

{$define EXTERNAL_SYMBOLS}
{$include corefoundation/Sources.inc}
{$include security/Sources.inc}
{$include foundation/Sources.inc}
{$include coregraphics/Sources.inc}
{$include opengles/Sources.inc}
{$include coreimage/Sources.inc}
{$include coretext/Sources.inc}
{$include quartzcore/Sources.inc}
{$include uikit/Sources.inc}
{$include mobilecoreservices/Sources.inc}
{$undef EXTERNAL_SYMBOLS}

{$include corefoundation/InlineFunctions.inc}
{$include security/InlineFunctions.inc}
{$include foundation/InlineFunctions.inc}
{$include coregraphics/InlineFunctions.inc}
{$include opengles/InlineFunctions.inc}
{$include coreimage/InlineFunctions.inc}
{$include coretext/InlineFunctions.inc}
{$include quartzcore/InlineFunctions.inc}
{$include uikit/InlineFunctions.inc}
{$include mobilecoreservices/InlineFunctions.inc}
{$endif}

{$ifdef IMPLEMENTATION}
{$include corefoundation/InlineFunctions.inc}
{$include security/InlineFunctions.inc}
{$include foundation/InlineFunctions.inc}
{$include coregraphics/InlineFunctions.inc}
{$include opengles/InlineFunctions.inc}
{$include coreimage/InlineFunctions.inc}
{$include coretext/InlineFunctions.inc}
{$include quartzcore/InlineFunctions.inc}
{$include uikit/InlineFunctions.inc}
{$include mobilecoreservices/InlineFunctions.inc}
{$endif}
