{ Parsed from MapKit.framework (iPhoneOS6.0) MKMapView.h }
{ Created on Wed Sep 12 7:28:16 2012 }


{$ifdef TYPES}
type
  MKMapViewPtr = ^MKMapView;
  MKMapViewDelegateProtocolPtr = ^MKMapViewDelegateProtocol;
{$endif}

{$if ((__IPHONE_5_0 <= __IPHONE_OS_VERSION_MAX_ALLOWED))}
{$ifdef TYPES}
const
  MKUserTrackingModeNone = 0;
  MKUserTrackingModeFollow = 1;
  MKUserTrackingModeFollowWithHeading = 2;
{$endif}

{$endif}
{$ifdef TYPES}
type
  MKUserTrackingMode = NSInteger;
  MKUserTrackingModePtr = ^MKUserTrackingMode;
{$endif}

{$ifdef CLASSES}

type
  MKMapView = objcclass external (UIView, NSCodingProtocol)
  private
    _internal: MKMapViewInternal;
  public
    procedure setDelegate(newValue: MKMapViewDelegateProtocol); message 'setDelegate:';
    function delegate: MKMapViewDelegateProtocol; message 'delegate';
    procedure setMapType(newValue: MKMapType); message 'setMapType:';
    function mapType: MKMapType; message 'mapType';
    procedure setRegion(newValue: MKCoordinateRegion); message 'setRegion:';
    function region: MKCoordinateRegion; message 'region';
    procedure setRegion_animated (region_: MKCoordinateRegion; animated: boolean); message 'setRegion:animated:';
    procedure setCenterCoordinate(newValue: CLLocationCoordinate2D); message 'setCenterCoordinate:';
    function centerCoordinate: CLLocationCoordinate2D; message 'centerCoordinate';
    procedure setCenterCoordinate_animated (coordinate: CLLocationCoordinate2D; animated: boolean); message 'setCenterCoordinate:animated:';
    function regionThatFits (region_: MKCoordinateRegion): MKCoordinateRegion; message 'regionThatFits:';
    procedure setVisibleMapRect(newValue: MKMapRect); message 'setVisibleMapRect:';
    function visibleMapRect: MKMapRect; message 'visibleMapRect';
    procedure setVisibleMapRect_animated (mapRect: MKMapRect; animate: boolean); message 'setVisibleMapRect:animated:';
    function mapRectThatFits (mapRect: MKMapRect): MKMapRect; message 'mapRectThatFits:';
    procedure setVisibleMapRect_edgePadding_animated (mapRect: MKMapRect; insets: UIEdgeInsets; animate: boolean); message 'setVisibleMapRect:edgePadding:animated:';
    function mapRectThatFits_edgePadding (mapRect: MKMapRect; insets: UIEdgeInsets): MKMapRect; message 'mapRectThatFits:edgePadding:';
    function convertCoordinate_toPointToView (coordinate: CLLocationCoordinate2D; view: UIView): CGPoint; message 'convertCoordinate:toPointToView:';
    function convertPoint_toCoordinateFromView (point: CGPoint; view: UIView): CLLocationCoordinate2D; message 'convertPoint:toCoordinateFromView:';
    function convertRegion_toRectToView (region_: MKCoordinateRegion; view: UIView): CGRect; message 'convertRegion:toRectToView:';
    function convertRect_toRegionFromView (rect: CGRect; view: UIView): MKCoordinateRegion; message 'convertRect:toRegionFromView:';
    procedure setZoomEnabled(newValue: boolean); message 'setZoomEnabled:';
    function isZoomEnabled: boolean; message 'isZoomEnabled';
    procedure setScrollEnabled(newValue: boolean); message 'setScrollEnabled:';
    function isScrollEnabled: boolean; message 'isScrollEnabled';
    procedure setShowsUserLocation(newValue: boolean); message 'setShowsUserLocation:';
    function showsUserLocation: boolean; message 'showsUserLocation';
    function userLocation: MKUserLocation; message 'userLocation';
    procedure setUserTrackingMode(newValue: MKUserTrackingMode); message 'setUserTrackingMode:';
    function userTrackingMode: MKUserTrackingMode; message 'userTrackingMode';
    procedure setUserTrackingMode_animated (mode: MKUserTrackingMode; animated: boolean); message 'setUserTrackingMode:animated:'; { available in NA, 5_0 }
    function isUserLocationVisible: boolean; message 'isUserLocationVisible';
    procedure addAnnotation (annotation: MKAnnotationProtocol); message 'addAnnotation:';
    procedure addAnnotations (annotations: NSArray); message 'addAnnotations:';
    procedure removeAnnotation (annotation: MKAnnotationProtocol); message 'removeAnnotation:';
    procedure removeAnnotations (annotations: NSArray); message 'removeAnnotations:';
    function annotations: NSArray; message 'annotations';
    function annotationsInMapRect (mapRect: MKMapRect): NSSet; message 'annotationsInMapRect:'; { available in NA, 4_2 }
    function viewForAnnotation (annotation: MKAnnotationProtocol): MKAnnotationView; message 'viewForAnnotation:';
    function dequeueReusableAnnotationViewWithIdentifier (identifier: NSString): MKAnnotationView; message 'dequeueReusableAnnotationViewWithIdentifier:';
    procedure selectAnnotation_animated (annotation: MKAnnotationProtocol; animated: boolean); message 'selectAnnotation:animated:';
    procedure deselectAnnotation_animated (annotation: MKAnnotationProtocol; animated: boolean); message 'deselectAnnotation:animated:';
    procedure setSelectedAnnotations(newValue: NSArray); message 'setSelectedAnnotations:';
    function selectedAnnotations: NSArray; message 'selectedAnnotations';
    function annotationVisibleRect: CGRect; message 'annotationVisibleRect';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;


type
  OverlaysAPI = objccategory external (MKMapView)
    procedure addOverlay (overlay: MKOverlayProtocol); message 'addOverlay:'; { available in NA, 4_0 }
    procedure addOverlays (overlays: NSArray); message 'addOverlays:'; { available in NA, 4_0 }
    procedure removeOverlay (overlay: MKOverlayProtocol); message 'removeOverlay:'; { available in NA, 4_0 }
    procedure removeOverlays (overlays: NSArray); message 'removeOverlays:'; { available in NA, 4_0 }
    procedure insertOverlay_atIndex (overlay: MKOverlayProtocol; index: NSUInteger); message 'insertOverlay:atIndex:'; { available in NA, 4_0 }
    procedure exchangeOverlayAtIndex_withOverlayAtIndex (index1: NSUInteger; index2: NSUInteger); message 'exchangeOverlayAtIndex:withOverlayAtIndex:'; { available in NA, 4_0 }
    procedure insertOverlay_aboveOverlay (overlay: MKOverlayProtocol; sibling: MKOverlayProtocol); message 'insertOverlay:aboveOverlay:'; { available in NA, 4_0 }
    procedure insertOverlay_belowOverlay (overlay: MKOverlayProtocol; sibling: MKOverlayProtocol); message 'insertOverlay:belowOverlay:'; { available in NA, 4_0 }
    function overlays: NSArray; message 'overlays';
    function viewForOverlay (overlay: MKOverlayProtocol): MKOverlayView; message 'viewForOverlay:'; { available in NA, 4_0 }
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  MKMapViewDelegateProtocol = objcprotocol external name 'MKMapViewDelegate' (NSObjectProtocol)
  optional
    procedure mapView_regionWillChangeAnimated (mapView: MKMapView; animated: boolean); message 'mapView:regionWillChangeAnimated:';
    procedure mapView_regionDidChangeAnimated (mapView: MKMapView; animated: boolean); message 'mapView:regionDidChangeAnimated:';
    procedure mapViewWillStartLoadingMap (mapView: MKMapView); message 'mapViewWillStartLoadingMap:';
    procedure mapViewDidFinishLoadingMap (mapView: MKMapView); message 'mapViewDidFinishLoadingMap:';
    procedure mapViewDidFailLoadingMap_withError (mapView: MKMapView; error: NSError); message 'mapViewDidFailLoadingMap:withError:';
    function mapView_viewForAnnotation (mapView: MKMapView; annotation: MKAnnotationProtocol): MKAnnotationView; message 'mapView:viewForAnnotation:';
    procedure mapView_didAddAnnotationViews (mapView: MKMapView; views: NSArray); message 'mapView:didAddAnnotationViews:';
    procedure mapView_annotationView_calloutAccessoryControlTapped (mapView: MKMapView; view: MKAnnotationView; control: UIControl); message 'mapView:annotationView:calloutAccessoryControlTapped:';
    procedure mapView_didSelectAnnotationView (mapView: MKMapView; view: MKAnnotationView); message 'mapView:didSelectAnnotationView:'; { available in NA, 4_0 }
    procedure mapView_didDeselectAnnotationView (mapView: MKMapView; view: MKAnnotationView); message 'mapView:didDeselectAnnotationView:'; { available in NA, 4_0 }
    procedure mapViewWillStartLocatingUser (mapView: MKMapView); message 'mapViewWillStartLocatingUser:'; { available in NA, 4_0 }
    procedure mapViewDidStopLocatingUser (mapView: MKMapView); message 'mapViewDidStopLocatingUser:'; { available in NA, 4_0 }
    procedure mapView_didUpdateUserLocation (mapView: MKMapView; userLocation: MKUserLocation); message 'mapView:didUpdateUserLocation:'; { available in NA, 4_0 }
    procedure mapView_didFailToLocateUserWithError (mapView: MKMapView; error: NSError); message 'mapView:didFailToLocateUserWithError:'; { available in NA, 4_0 }
    procedure mapView_annotationView_didChangeDragState_fromOldState (mapView: MKMapView; view: MKAnnotationView; newState: MKAnnotationViewDragState; oldState: MKAnnotationViewDragState); message 'mapView:annotationView:didChangeDragState:fromOldState:'; { available in NA, 4_0 }
    function mapView_viewForOverlay (mapView: MKMapView; overlay: MKOverlayProtocol): MKOverlayView; message 'mapView:viewForOverlay:'; { available in NA, 4_0 }
    procedure mapView_didAddOverlayViews (mapView: MKMapView; overlayViews: NSArray); message 'mapView:didAddOverlayViews:'; { available in NA, 4_0 }
    procedure mapView_didChangeUserTrackingMode_animated (mapView: MKMapView; mode: MKUserTrackingMode; animated: boolean); message 'mapView:didChangeUserTrackingMode:animated:'; { available in NA, 5_0 }
  end;
{$endif}

