{ Parsed from MediaPlayer.framework (iPhoneOS6.0) MPMusicPlayerController.h }
{ Created on Wed Sep 12 7:28:18 2012 }


{$ifdef TYPES}
type
  MPMusicPlayerControllerPtr = ^MPMusicPlayerController;
{$endif}

{$ifdef TYPES}
const
  MPMusicPlaybackStateStopped = 0;
  MPMusicPlaybackStatePlaying = 1;
  MPMusicPlaybackStatePaused = 2;
  MPMusicPlaybackStateInterrupted = 3;
  MPMusicPlaybackStateSeekingForward = 4;
  MPMusicPlaybackStateSeekingBackward = 5;

type
  MPMusicPlaybackState = NSInteger;
  MPMusicPlaybackStatePtr = ^MPMusicPlaybackState;

const
  MPMusicRepeatModeDefault = 0;
  MPMusicRepeatModeNone = 1;
  MPMusicRepeatModeOne = 2;
  MPMusicRepeatModeAll = 3;

type
  MPMusicRepeatMode = NSInteger;
  MPMusicRepeatModePtr = ^MPMusicRepeatMode;

const
  MPMusicShuffleModeDefault = 0;
  MPMusicShuffleModeOff = 1;
  MPMusicShuffleModeSongs = 2;
  MPMusicShuffleModeAlbums = 3;

type
  MPMusicShuffleMode = NSInteger { available in 3_0 };
  MPMusicShuffleModePtr = ^MPMusicShuffleMode { available in 3_0 };
{$endif}

{$ifdef CLASSES}

type
  MPMusicPlayerController = objcclass external (NSObject, MPMediaPlaybackProtocol)
  public
    class function applicationMusicPlayer: MPMusicPlayerController; message 'applicationMusicPlayer';
    class function iPodMusicPlayer: MPMusicPlayerController; message 'iPodMusicPlayer';

    { Adopted protocols }
    procedure beginSeekingBackward; message 'beginSeekingBackward';
    procedure beginSeekingForward; message 'beginSeekingForward';
    procedure setCurrentPlaybackRate(newValue: single); message 'setCurrentPlaybackRate:';
    function currentPlaybackRate: single; message 'currentPlaybackRate';
    procedure setCurrentPlaybackTime(newValue: NSTimeInterval); message 'setCurrentPlaybackTime:';
    function currentPlaybackTime: NSTimeInterval; message 'currentPlaybackTime';
    procedure endSeeking; message 'endSeeking';
    function isPreparedToPlay: boolean; message 'isPreparedToPlay';
    procedure pause; message 'pause';
    procedure play; message 'play';
    procedure prepareToPlay; message 'prepareToPlay';
    procedure stop; message 'stop';
  end;


type
  MPPlaybackControl = objccategory external (MPMusicPlayerController)
    function playbackState: MPMusicPlaybackState; message 'playbackState';
    procedure setRepeatMode(newValue: MPMusicRepeatMode); message 'setRepeatMode:';
    function repeatMode: MPMusicRepeatMode; message 'repeatMode';
    procedure setShuffleMode(newValue: MPMusicShuffleMode); message 'setShuffleMode:';
    function shuffleMode: MPMusicShuffleMode; message 'shuffleMode';
    procedure setVolume(newValue: single); message 'setVolume:';
    function volume: single; message 'volume';
    procedure setNowPlayingItem(newValue: MPMediaItem); message 'setNowPlayingItem:';
    function nowPlayingItem: MPMediaItem; message 'nowPlayingItem';
    function indexOfNowPlayingItem: NSUInteger; message 'indexOfNowPlayingItem';
    procedure setQueueWithQuery (query: MPMediaQuery); message 'setQueueWithQuery:';
    procedure setQueueWithItemCollection (itemCollection: MPMediaItemCollection); message 'setQueueWithItemCollection:';
    procedure skipToNextItem; message 'skipToNextItem';
    procedure skipToBeginning; message 'skipToBeginning';
    procedure skipToPreviousItem; message 'skipToPreviousItem';
    procedure beginGeneratingPlaybackNotifications; message 'beginGeneratingPlaybackNotifications';
    procedure endGeneratingPlaybackNotifications; message 'endGeneratingPlaybackNotifications';
  end;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  MPMusicPlayerControllerPlaybackStateDidChangeNotification: NSString; cvar; external;
  MPMusicPlayerControllerNowPlayingItemDidChangeNotification: NSString; cvar; external;
  MPMusicPlayerControllerVolumeDidChangeNotification: NSString; cvar; external;
{$endif}

