{ Parsed from UIKit.framework (iPhoneOS6.0) UIAlertView.h }
{ Created on Wed Sep 12 7:28:48 2012 }


{$ifdef TYPES}
type
  UIAlertViewPtr = ^UIAlertView;
  UIAlertViewDelegateProtocolPtr = ^UIAlertViewDelegateProtocol;
{$endif}

{$ifdef TYPES}
type
  UIAlertViewStyle = NSInteger;
  UIAlertViewStylePtr = ^UIAlertViewStyle;

const
  UIAlertViewStyleDefault = 0;
  UIAlertViewStyleSecureTextInput = 1;
  UIAlertViewStylePlainTextInput = 2;
  UIAlertViewStyleLoginAndPasswordInput = 3;
{$endif}

{$ifdef CLASSES}

type
  UIAlertView = objcclass external (UIView)
  private
    _delegate: UIAlertViewDelegateProtocol;
    _titleLabel: UILabel;
    _subtitleLabel: UILabel;
    _bodyTextLabel: UILabel;
    _taglineTextLabel: UILabel;
    _startY: CGFloat;
    _center: CGPoint;
    _context: id;
    _cancelButton: NSInteger;
    _defaultButton: NSInteger;
    _firstOtherButton: NSInteger;
    _toolbar: UIToolbar;
    _originalWindow: UIWindow;
    _dimWindow: UIWindow;
    _suspendTag: NSInteger;
    _dismissButtonIndex: NSInteger;
    _bodyTextHeight: CGFloat;
    _buttons: NSMutableArray;
    _textFields: NSMutableArray;
    _keyboard: UIView;
    _table: UIView;
    _dimView: UIView;
    _backgroundImageView: UIView;
    _modalViewFlags: bitpacked record
      case byte of
        0: (_anonBitField__modalViewFlags0: cuint);
        1: (
          numberOfRows: 0..((1 shl 7)-1);
          delegateAlertSheetButtonClicked: 0..1;
          delegateDidPresentAlertSheet: 0..1;
          delegateDidDismissAlertSheet: 0..1;
          hideButtonBar: 0..1;
          alertStyle: 0..((1 shl 3)-1);
          dontDimBackground: 0..1;
          dismissSuspended: 0..1;
          dontBlockInteraction: 0..1;
          sheetWasPoppedUp: 0..1;
          animating: 0..1;
          hideWhenDoneAnimating: 0..1;
          layoutWhenDoneAnimating: 0..1;
          titleMaxLineCount: 0..((1 shl 2)-1);
          bodyTextMaxLineCount: 0..((1 shl 3)-1);
          runsModal: 0..1;
          runningModal: 0..1;
          addedTextView: 0..1;
          addedTableShadows: 0..1;
          showOverSBAlerts: 0..1;
          showMinTableContent: 0..1;
          bodyTextTruncated: 0..1;
          orientation: 0..((1 shl 3)-1);
          groupsTextFields: 0..1;
          includesCancel: 0..1;
          useUndoStyle: 0..1;
          delegateBodyTextAlignment: 0..1;
          delegateClickedButtonAtIndex: 0..1;
          delegateClickedButtonAtIndex2: 0..1;
          delegateCancel: 0..1;
          delegateCancel2: 0..1;
          delegateWillPresent: 0..1;
          delegateWillPresent2: 0..1;
          delegateDidPresent: 0..1;
          delegateDidPresent2: 0..1;
          delegateWillDismiss: 0..1;
          delegateWillDismiss2: 0..1;
          delegateDidDismiss: 0..1;
          delegateDidDismiss2: 0..1;
          delegateShouldEnableFirstOtherButton: 0..1;
          forceHorizontalButtonsLayout: 0..1;
          suppressKeyboardOnPopup: 0..1;
          keyboardShowing: 0..1;
          dontCallDismissDelegate: 0..1;
          useAutomaticKB: 0..1;
          manualKeyboardVisible: 0..1;
          rotatingManualKeybaord: 0..1;
          shouldHandleFirstKeyUpEvent: 0..1;
          forceKeyboardUse: 0..1;
          cancelWhenDoneAnimating: 0..1;
          alertViewStyle: 0..((1 shl 3)-1);
          isSBAlert: 0..1;
          isBeingDismissed: 0..1;
        );
      end;
  public
    function initWithTitle_message_delegate_cancelButtonTitle_otherButtonTitles (title: NSString; message_: NSString; delegate: id; cancelButtonTitle: NSString; otherButtonTitles: NSString): id; varargs; message 'initWithTitle:message:delegate:cancelButtonTitle:otherButtonTitles:';
    procedure setDelegate(newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setTitle(newValue: NSString); message 'setTitle:';
    function title: NSString; message 'title';
    procedure setMessage(newValue: NSString); message 'setMessage:';
    function message_: NSString; message 'message';
    function addButtonWithTitle (title_: NSString): NSInteger; message 'addButtonWithTitle:';
    function buttonTitleAtIndex (buttonIndex: NSInteger): NSString; message 'buttonTitleAtIndex:';
    function numberOfButtons: NSInteger; message 'numberOfButtons';
    procedure setCancelButtonIndex(newValue: NSInteger); message 'setCancelButtonIndex:';
    function cancelButtonIndex: NSInteger; message 'cancelButtonIndex';
    function firstOtherButtonIndex: NSInteger; message 'firstOtherButtonIndex';
    function isVisible: boolean; message 'isVisible';
    procedure show; message 'show';
    procedure dismissWithClickedButtonIndex_animated (buttonIndex: NSInteger; animated: boolean); message 'dismissWithClickedButtonIndex:animated:';
    procedure setAlertViewStyle(newValue: UIAlertViewStyle); message 'setAlertViewStyle:';
    function alertViewStyle: UIAlertViewStyle; message 'alertViewStyle';
    function textFieldAtIndex (textFieldIndex: NSInteger): UITextField; message 'textFieldAtIndex:'; { available in 5_0 }
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UIAlertViewDelegateProtocol = objcprotocol external name 'UIAlertViewDelegate' (NSObjectProtocol)
  optional
    procedure alertView_clickedButtonAtIndex (alertView: UIAlertView; buttonIndex: NSInteger); message 'alertView:clickedButtonAtIndex:';
    procedure alertViewCancel (alertView: UIAlertView); message 'alertViewCancel:';
    procedure willPresentAlertView (alertView: UIAlertView); message 'willPresentAlertView:';
    procedure didPresentAlertView (alertView: UIAlertView); message 'didPresentAlertView:';
    procedure alertView_willDismissWithButtonIndex (alertView: UIAlertView; buttonIndex: NSInteger); message 'alertView:willDismissWithButtonIndex:';
    procedure alertView_didDismissWithButtonIndex (alertView: UIAlertView; buttonIndex: NSInteger); message 'alertView:didDismissWithButtonIndex:';
    function alertViewShouldEnableFirstOtherButton (alertView: UIAlertView): boolean; message 'alertViewShouldEnableFirstOtherButton:';
  end;
{$endif}

