{ Parsed from UIKit.framework (iPhoneOS6.0) UICollectionViewFlowLayout.h }
{ Created on Wed Sep 12 7:28:48 2012 }


{$ifdef TYPES}
type
  UICollectionViewFlowLayoutPtr = ^UICollectionViewFlowLayout;
  UICollectionViewDelegateFlowLayoutProtocolPtr = ^UICollectionViewDelegateFlowLayoutProtocol;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UICollectionElementKindSectionHeader: NSString; cvar; external;
  UICollectionElementKindSectionFooter: NSString; cvar; external;
{$endif}

{$ifdef TYPES}
type
  UICollectionViewScrollDirection = NSInteger;
  UICollectionViewScrollDirectionPtr = ^UICollectionViewScrollDirection;

const
  UICollectionViewScrollDirectionVertical = 0;
  UICollectionViewScrollDirectionHorizontal = 1;
{$endif}

{$ifdef PROTOCOLS}

type
  UICollectionViewDelegateFlowLayoutProtocol = objcprotocol external name 'UICollectionViewDelegateFlowLayout' (UICollectionViewDelegateProtocol)
  optional
    function collectionView_layout_sizeForItemAtIndexPath (collectionView: UICollectionView; collectionViewLayout: UICollectionViewLayout; indexPath: NSIndexPath): CGSize; message 'collectionView:layout:sizeForItemAtIndexPath:';
    function collectionView_layout_insetForSectionAtIndex (collectionView: UICollectionView; collectionViewLayout: UICollectionViewLayout; section: NSInteger): UIEdgeInsets; message 'collectionView:layout:insetForSectionAtIndex:';
    function collectionView_layout_minimumLineSpacingForSectionAtIndex (collectionView: UICollectionView; collectionViewLayout: UICollectionViewLayout; section: NSInteger): CGFloat; message 'collectionView:layout:minimumLineSpacingForSectionAtIndex:';
    function collectionView_layout_minimumInteritemSpacingForSectionAtIndex (collectionView: UICollectionView; collectionViewLayout: UICollectionViewLayout; section: NSInteger): CGFloat; message 'collectionView:layout:minimumInteritemSpacingForSectionAtIndex:';
    function collectionView_layout_referenceSizeForHeaderInSection (collectionView: UICollectionView; collectionViewLayout: UICollectionViewLayout; section: NSInteger): CGSize; message 'collectionView:layout:referenceSizeForHeaderInSection:';
    function collectionView_layout_referenceSizeForFooterInSection (collectionView: UICollectionView; collectionViewLayout: UICollectionViewLayout; section: NSInteger): CGSize; message 'collectionView:layout:referenceSizeForFooterInSection:';
  end;
{$endif}

{$ifdef CLASSES}

type
  UICollectionViewFlowLayout = objcclass external (UICollectionViewLayout)
  private
    _gridLayoutFlags: bitpacked record
      case byte of
        0: (_anonBitField__gridLayoutFlags0: cuint);
        1: (
          delegateSizeForItem: 0..1;
          delegateReferenceSizeForHeader: 0..1;
          delegateReferenceSizeForFooter: 0..1;
          delegateInsetForSection: 0..1;
          delegateInteritemSpacingForSection: 0..1;
          delegateLineSpacingForSection: 0..1;
          delegateAlignmentOptions: 0..1;
          keepDelegateInfoWhileInvalidating: 0..1;
          keepAllDataWhileInvalidating: 0..1;
          layoutDataIsValid: 0..1;
          delegateInfoIsValid: 0..1;
        );
      end;
    _interitemSpacing: CGFloat;
    _lineSpacing: CGFloat;
    _itemSize: CGSize;
    _headerReferenceSize: CGSize;
    _footerReferenceSize: CGSize;
    _sectionInset: UIEdgeInsets;
    _data: id;
    _currentLayoutSize: CGSize;
    _insertedItemsAttributesDict: NSMutableDictionary;
    _insertedSectionHeadersAttributesDict: NSMutableDictionary;
    _insertedSectionFootersAttributesDict: NSMutableDictionary;
    _deletedItemsAttributesDict: NSMutableDictionary;
    _deletedSectionHeadersAttributesDict: NSMutableDictionary;
    _deletedSectionFootersAttributesDict: NSMutableDictionary;
    _scrollDirection: UICollectionViewScrollDirection;
    _rowAlignmentsOptionsDictionary: NSDictionary;
    _visibleBounds: CGRect;
  public
    procedure setMinimumLineSpacing(newValue: CGFloat); message 'setMinimumLineSpacing:';
    function minimumLineSpacing: CGFloat; message 'minimumLineSpacing';
    procedure setMinimumInteritemSpacing(newValue: CGFloat); message 'setMinimumInteritemSpacing:';
    function minimumInteritemSpacing: CGFloat; message 'minimumInteritemSpacing';
    procedure setItemSize(newValue: CGSize); message 'setItemSize:';
    function itemSize: CGSize; message 'itemSize';
    procedure setScrollDirection(newValue: UICollectionViewScrollDirection); message 'setScrollDirection:';
    function scrollDirection: UICollectionViewScrollDirection; message 'scrollDirection';
    procedure setHeaderReferenceSize(newValue: CGSize); message 'setHeaderReferenceSize:';
    function headerReferenceSize: CGSize; message 'headerReferenceSize';
    procedure setFooterReferenceSize(newValue: CGSize); message 'setFooterReferenceSize:';
    function footerReferenceSize: CGSize; message 'footerReferenceSize';
    procedure setSectionInset(newValue: UIEdgeInsets); message 'setSectionInset:';
    function sectionInset: UIEdgeInsets; message 'sectionInset';
  end;
{$endif}

