{ Parsed from UIKit.framework (iPhoneOS6.0) UICollectionViewLayout.h }
{ Created on Wed Sep 12 7:28:48 2012 }


{$ifdef TYPES}
type
  UICollectionViewLayoutAttributesPtr = ^UICollectionViewLayoutAttributes;
  UICollectionViewUpdateItemPtr = ^UICollectionViewUpdateItem;
  UICollectionViewLayoutPtr = ^UICollectionViewLayout;
{$endif}

{$ifdef TYPES}
type
  UICollectionElementCategory = NSUInteger;
  UICollectionElementCategoryPtr = ^UICollectionElementCategory;

const
  UICollectionElementCategoryCell = 0;
  UICollectionElementCategorySupplementaryView = 1;
  UICollectionElementCategoryDecorationView = 2;
{$endif}

{$ifdef CLASSES}

type
  UICollectionViewLayoutAttributes = objcclass external (NSObject, NSCopyingProtocol)
  private
    _elementKind: NSString;
    _reuseIdentifer: NSString;
    _center: CGPoint;
    _size: CGSize;
    _frame: CGRect;
    _alpha: CGFloat;
    _transform: CATransform3D;
    _indexPath: NSIndexPath;
    _layoutFlags: bitpacked record
      case byte of
        0: (_anonBitField__layoutFlags0: cuint);
        1: (
          isCellKind: 0..1;
          isDecorationView: 0..1;
          isHidden: 0..1;
        );
      end;
  public
    procedure setFrame(newValue: CGRect); message 'setFrame:';
    function frame: CGRect; message 'frame';
    procedure setCenter(newValue: CGPoint); message 'setCenter:';
    function center: CGPoint; message 'center';
    procedure setSize(newValue: CGSize); message 'setSize:';
    function size: CGSize; message 'size';
    procedure setTransform3D(newValue: CATransform3D); message 'setTransform3D:';
    function transform3D: CATransform3D; message 'transform3D';
    procedure setAlpha(newValue: CGFloat); message 'setAlpha:';
    function alpha: CGFloat; message 'alpha';
    procedure setZIndex(newValue: NSInteger); message 'setZIndex:';
    function zIndex: NSInteger; message 'zIndex';
    procedure setHidden(newValue: boolean); message 'setHidden:';
    function isHidden: boolean; message 'isHidden';
    procedure setIndexPath(newValue: NSIndexPath); message 'setIndexPath:';
    function indexPath: NSIndexPath; message 'indexPath';
    function representedElementCategory: UICollectionElementCategory; message 'representedElementCategory';
    function representedElementKind: NSString; message 'representedElementKind';
    class function layoutAttributesForCellWithIndexPath (indexPath_: NSIndexPath): instancetype; message 'layoutAttributesForCellWithIndexPath:';
    class function layoutAttributesForSupplementaryViewOfKind_withIndexPath (elementKind: NSString; indexPath_: NSIndexPath): instancetype; message 'layoutAttributesForSupplementaryViewOfKind:withIndexPath:';
    class function layoutAttributesForDecorationViewOfKind_withIndexPath (decorationViewKind: NSString; indexPath_: NSIndexPath): instancetype; message 'layoutAttributesForDecorationViewOfKind:withIndexPath:';

    { Adopted protocols }
    function copyWithZone (zone: NSZonePtr): id; message 'copyWithZone:';
  end;
{$endif}

{$ifdef TYPES}
type
  UICollectionUpdateAction = NSInteger;
  UICollectionUpdateActionPtr = ^UICollectionUpdateAction;

const
  UICollectionUpdateActionInsert = 0;
  UICollectionUpdateActionDelete = 1;
  UICollectionUpdateActionReload = 2;
  UICollectionUpdateActionMove = 3;
  UICollectionUpdateActionNone = 4;
{$endif}

{$ifdef CLASSES}

type
  UICollectionViewUpdateItem = objcclass external (NSObject)
  private
    _initialIndexPath: NSIndexPath;
    _finalIndexPath: NSIndexPath;
    _updateAction: UICollectionUpdateAction;
    _gap: id;
  public
    function indexPathBeforeUpdate: NSIndexPath; message 'indexPathBeforeUpdate';
    function indexPathAfterUpdate: NSIndexPath; message 'indexPathAfterUpdate';
    function updateAction: UICollectionUpdateAction; message 'updateAction';
  end;

type
  UICollectionViewLayout = objcclass external (NSObject, NSCodingProtocol)
  private
    _collectionView: UICollectionView;
    _collectionViewBoundsSize: CGSize;
    _initialAnimationLayoutAttributesDict: NSMutableDictionary;
    _finalAnimationLayoutAttributesDict: NSMutableDictionary;
    _deletedSectionsSet: NSMutableIndexSet;
    _insertedSectionsSet: NSMutableIndexSet;
    _decorationViewClassDict: NSMutableDictionary;
    _decorationViewNibDict: NSMutableDictionary;
    _decorationViewExternalObjectsTables: NSMutableDictionary;
  public
    function collectionView: UICollectionView; message 'collectionView';
    procedure invalidateLayout; message 'invalidateLayout';
    procedure registerClass_forDecorationViewOfKind (viewClass: pobjc_class; decorationViewKind: NSString); message 'registerClass:forDecorationViewOfKind:';
    procedure registerNib_forDecorationViewOfKind (nib: UINib; decorationViewKind: NSString); message 'registerNib:forDecorationViewOfKind:';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;


type
  SubclassingHooks = objccategory external (UICollectionViewLayout)
    class function layoutAttributesClass: pobjc_class; message 'layoutAttributesClass';
    procedure prepareLayout; message 'prepareLayout';
    function layoutAttributesForElementsInRect (rect: CGRect): NSArray; message 'layoutAttributesForElementsInRect:';
    function layoutAttributesForItemAtIndexPath (indexPath: NSIndexPath): UICollectionViewLayoutAttributes; message 'layoutAttributesForItemAtIndexPath:';
    function layoutAttributesForSupplementaryViewOfKind_atIndexPath (kind: NSString; indexPath: NSIndexPath): UICollectionViewLayoutAttributes; message 'layoutAttributesForSupplementaryViewOfKind:atIndexPath:';
    function layoutAttributesForDecorationViewOfKind_atIndexPath (decorationViewKind: NSString; indexPath: NSIndexPath): UICollectionViewLayoutAttributes; message 'layoutAttributesForDecorationViewOfKind:atIndexPath:';
    function shouldInvalidateLayoutForBoundsChange (newBounds: CGRect): boolean; message 'shouldInvalidateLayoutForBoundsChange:';
    function targetContentOffsetForProposedContentOffset_withScrollingVelocity (proposedContentOffset: CGPoint; velocity: CGPoint): CGPoint; message 'targetContentOffsetForProposedContentOffset:withScrollingVelocity:';
    function collectionViewContentSize: CGSize; message 'collectionViewContentSize';
  end;

type
  UpdateSupportHooks = objccategory external (UICollectionViewLayout)
    procedure prepareForCollectionViewUpdates (updateItems: NSArray); message 'prepareForCollectionViewUpdates:';
    procedure finalizeCollectionViewUpdates; message 'finalizeCollectionViewUpdates';
    procedure prepareForAnimatedBoundsChange (oldBounds: CGRect); message 'prepareForAnimatedBoundsChange:';
    procedure finalizeAnimatedBoundsChange; message 'finalizeAnimatedBoundsChange';
    function initialLayoutAttributesForAppearingItemAtIndexPath (itemIndexPath: NSIndexPath): UICollectionViewLayoutAttributes; message 'initialLayoutAttributesForAppearingItemAtIndexPath:';
    function finalLayoutAttributesForDisappearingItemAtIndexPath (itemIndexPath: NSIndexPath): UICollectionViewLayoutAttributes; message 'finalLayoutAttributesForDisappearingItemAtIndexPath:';
    function initialLayoutAttributesForAppearingSupplementaryElementOfKind_atIndexPath (elementKind: NSString; elementIndexPath: NSIndexPath): UICollectionViewLayoutAttributes; message 'initialLayoutAttributesForAppearingSupplementaryElementOfKind:atIndexPath:';
    function finalLayoutAttributesForDisappearingSupplementaryElementOfKind_atIndexPath (elementKind: NSString; elementIndexPath: NSIndexPath): UICollectionViewLayoutAttributes; message 'finalLayoutAttributesForDisappearingSupplementaryElementOfKind:atIndexPath:';
    function initialLayoutAttributesForAppearingDecorationElementOfKind_atIndexPath (elementKind: NSString; decorationIndexPath: NSIndexPath): UICollectionViewLayoutAttributes; message 'initialLayoutAttributesForAppearingDecorationElementOfKind:atIndexPath:';
    function finalLayoutAttributesForDisappearingDecorationElementOfKind_atIndexPath (elementKind: NSString; decorationIndexPath: NSIndexPath): UICollectionViewLayoutAttributes; message 'finalLayoutAttributesForDisappearingDecorationElementOfKind:atIndexPath:';
  end;
{$endif}

