{ Parsed from UIKit.framework (iPhoneOS6.0) UIImage.h }
{ Created on Wed Sep 12 7:28:48 2012 }


{$ifdef TYPES}
type
  UIImagePtr = ^UIImage;
{$endif}

{$ifdef TYPES}
type
  UIImageOrientation = NSInteger;
  UIImageOrientationPtr = ^UIImageOrientation;

const
  UIImageOrientationUp = 0;
  UIImageOrientationDown = 1;
  UIImageOrientationLeft = 2;
  UIImageOrientationRight = 3;
  UIImageOrientationUpMirrored = 4;
  UIImageOrientationDownMirrored = 5;
  UIImageOrientationLeftMirrored = 6;
  UIImageOrientationRightMirrored = 7;

type
  UIImageResizingMode = NSInteger;
  UIImageResizingModePtr = ^UIImageResizingMode;

const
  UIImageResizingModeTile = 0;
  UIImageResizingModeStretch = 1;
{$endif}

{$ifdef CLASSES}

type
  UIImage = objcclass external (NSObject, NSCodingProtocol)
  private
    _imageRef: CFTypeRef;
    _scale: CGFloat;
    _imageFlags: bitpacked record
      case byte of
        0: (_anonBitField__imageFlags0: cuint);
        1: (
          named: 0..1;
          imageOrientation: 0..((1 shl 3)-1);
          cached: 0..1;
          hasPattern: 0..1;
          isCIImage: 0..1;
          imageSetIdentifer: 0..((1 shl 16)-1);
        );
      end;
  public
    class function imageNamed (name: NSString): UIImage; message 'imageNamed:';
    class function imageWithContentsOfFile (path: NSString): UIImage; message 'imageWithContentsOfFile:';
    class function imageWithData (data: NSData): UIImage; message 'imageWithData:';
    class function imageWithData_scale (data: NSData; scale: CGFloat): UIImage; message 'imageWithData:scale:'; { available in 6_0 }
    class function imageWithCGImage (cgImage: CGImageRef): UIImage; message 'imageWithCGImage:';
    class function imageWithCGImage_scale_orientation (cgImage: CGImageRef; scale: CGFloat; orientation: UIImageOrientation): UIImage; message 'imageWithCGImage:scale:orientation:'; { available in 4_0 }
    class function imageWithCIImage (ciImage_: CIImage): UIImage; message 'imageWithCIImage:'; { available in 5_0 }
    class function imageWithCIImage_scale_orientation (ciImage_: CIImage; scale: CGFloat; orientation: UIImageOrientation): UIImage; message 'imageWithCIImage:scale:orientation:'; { available in 6_0 }
    function initWithContentsOfFile (path: NSString): id; message 'initWithContentsOfFile:';
    function initWithData (data: NSData): id; message 'initWithData:';
    function initWithData_scale (data: NSData; scale: CGFloat): id; message 'initWithData:scale:'; { available in 6_0 }
    function initWithCGImage (cgImage: CGImageRef): id; message 'initWithCGImage:';
    function initWithCGImage_scale_orientation (cgImage: CGImageRef; scale: CGFloat; orientation: UIImageOrientation): id; message 'initWithCGImage:scale:orientation:'; { available in 4_0 }
    function initWithCIImage (ciImage_: CIImage): id; message 'initWithCIImage:'; { available in 5_0 }
    function initWithCIImage_scale_orientation (ciImage_: CIImage; scale: CGFloat; orientation: UIImageOrientation): id; message 'initWithCIImage:scale:orientation:'; { available in 6_0 }
    function size: CGSize; message 'size';
    function CGImage: CGImageRef; message 'CGImage';
    function CIImage_: CIImage; message 'CIImage';
    function imageOrientation: UIImageOrientation; message 'imageOrientation';
    function scale: CGFloat; message 'scale';
    class function animatedImageNamed_duration (name: NSString; duration: NSTimeInterval): UIImage; message 'animatedImageNamed:duration:'; { available in 5_0 }
    class function animatedResizableImageNamed_capInsets_duration (name: NSString; capInsets: UIEdgeInsets; duration: NSTimeInterval): UIImage; message 'animatedResizableImageNamed:capInsets:duration:'; { available in 5_0 }
    class function animatedResizableImageNamed_capInsets_resizingMode_duration (name: NSString; capInsets: UIEdgeInsets; resizingMode: UIImageResizingMode; duration: NSTimeInterval): UIImage; message 'animatedResizableImageNamed:capInsets:resizingMode:duration:'; { available in 6_0 }
    class function animatedImageWithImages_duration (images: NSArray; duration: NSTimeInterval): UIImage; message 'animatedImageWithImages:duration:'; { available in 5_0 }
    function images: NSArray; message 'images';
    function duration: NSTimeInterval; message 'duration';
    procedure drawAtPoint (point: CGPoint); message 'drawAtPoint:';
    procedure drawAtPoint_blendMode_alpha (point: CGPoint; blendMode: CGBlendMode; alpha: CGFloat); message 'drawAtPoint:blendMode:alpha:';
    procedure drawInRect (rect: CGRect); message 'drawInRect:';
    procedure drawInRect_blendMode_alpha (rect: CGRect; blendMode: CGBlendMode; alpha: CGFloat); message 'drawInRect:blendMode:alpha:';
    procedure drawAsPatternInRect (rect: CGRect); message 'drawAsPatternInRect:';
    function resizableImageWithCapInsets (capInsets: UIEdgeInsets): UIImage; message 'resizableImageWithCapInsets:'; { available in 5_0 }
    function resizableImageWithCapInsets_resizingMode (capInsets: UIEdgeInsets; resizingMode: UIImageResizingMode): UIImage; message 'resizableImageWithCapInsets:resizingMode:'; { available in 6_0 }
    function capInsets: UIEdgeInsets; message 'capInsets';
    function resizingMode: UIImageResizingMode; message 'resizingMode';
    function imageWithAlignmentRectInsets (alignmentInsets: UIEdgeInsets): UIImage; message 'imageWithAlignmentRectInsets:'; { available in 6_0 }
    function alignmentRectInsets: UIEdgeInsets; message 'alignmentRectInsets';

    { Adopted protocols }
    procedure encodeWithCoder (aCoder: NSCoder); message 'encodeWithCoder:';
    function initWithCoder (aDecoder: NSCoder): id; message 'initWithCoder:';
  end;


type
  UIImageDeprecated = objccategory external (UIImage)
    function stretchableImageWithLeftCapWidth_topCapHeight (leftCapWidth: NSInteger; topCapHeight: NSInteger): UIImage; message 'stretchableImageWithLeftCapWidth:topCapHeight:';
    function leftCapWidth: NSInteger; message 'leftCapWidth';
    function topCapHeight: NSInteger; message 'topCapHeight';
  end;

type
  UIKitAdditions = objccategory external (CIImage)
    function initWithImage (image: UIImage): id; message 'initWithImage:'; { available in 5_0 }
    function initWithImage_options (image: UIImage; options: NSDictionary): id; message 'initWithImage:options:'; { available in 5_0 }
  end;
{$endif}

{$ifdef FUNCTIONS}
function UIImagePNGRepresentation(image: UIImage): NSData; cdecl; external;
function UIImageJPEGRepresentation(image: UIImage; compressionQuality: CGFloat): NSData; cdecl; external;
{$endif}

