{ Parsed from UIKit.framework (iPhoneOS6.0) UINavigationController.h }
{ Created on Wed Sep 12 7:28:48 2012 }


{$ifdef TYPES}
type
  UINavigationControllerPtr = ^UINavigationController;
  UINavigationControllerDelegateProtocolPtr = ^UINavigationControllerDelegateProtocol;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UINavigationControllerHideShowBarDuration: CGFloat; cvar; external;
{$endif}

{$ifdef CLASSES}

type
  UINavigationController = objcclass external (UIViewController)
  private
    _containerView: UIView;
    _navigationBar: UINavigationBar;
    _navigationBarClass: pobjc_class;
    _toolbar: UIToolbar;
    _navigationTransitionView: UIView;
    _currentScrollContentInsetDelta: UIEdgeInsets;
    _previousScrollContentInsetDelta: UIEdgeInsets;
    _previousScrollContentOffsetDelta: CGFloat;
    _bottomInsetDelta: CGFloat;
    _disappearingViewController: UIViewController;
    _delegate: UINavigationControllerDelegateProtocol;
    _savedNavBarStyleBeforeSheet: UIBarStyle;
    _savedToolBarStyleBeforeSheet: UIBarStyle;
    _navigationControllerFlags: bitpacked record
      case byte of
        0: (_anonBitField__navigationControllerFlags0: cuint);
        1: (
          isAppearingAnimated: 0..1;
          isAlreadyPoppingNavigationItem: 0..1;
          isNavigationBarHidden: 0..1;
          isToolbarShown: 0..1;
          needsDeferredTransition: 0..1;
          isTransitioning: 0..1;
          lastOperation: 0..((1 shl 4)-1);
          lastOperationAnimated: 0..1;
          deferredTransition: 0..((1 shl 8)-1);
          didPreloadKeyboardAnimation: 0..1;
          didHideBottomBar: 0..1;
          isChangingOrientationForPop: 0..1;
          pretendNavBarHidden: 0..1;
          avoidMovingNavBarOffscreenBeforeUnhiding: 0..1;
          searchBarHidNavBar: 0..1;
          useSystemPopoverBarAppearance: 0..1;
          isCustomTransition: 0..1;
        );
      end;
  public
    function initWithNavigationBarClass_toolbarClass (navigationBarClass: pobjc_class; toolbarClass: pobjc_class): instancetype; message 'initWithNavigationBarClass:toolbarClass:'; { available in 5_0 }
    function initWithRootViewController (rootViewController: UIViewController): id; message 'initWithRootViewController:';
    procedure pushViewController_animated (viewController: UIViewController; animated: boolean); message 'pushViewController:animated:';
    function popViewControllerAnimated (animated: boolean): UIViewController; message 'popViewControllerAnimated:';
    function popToViewController_animated (viewController: UIViewController; animated: boolean): NSArray; message 'popToViewController:animated:';
    function popToRootViewControllerAnimated (animated: boolean): NSArray; message 'popToRootViewControllerAnimated:';
    function topViewController: UIViewController; message 'topViewController';
    function visibleViewController: UIViewController; message 'visibleViewController';
    procedure setViewControllers(newValue: NSArray); message 'setViewControllers:';
    function viewControllers: NSArray; message 'viewControllers';
    procedure setViewControllers_animated (viewControllers_: NSArray; animated: boolean); message 'setViewControllers:animated:'; { available in 3_0 }
    procedure setNavigationBarHidden(newValue: boolean); message 'setNavigationBarHidden:';
    function isNavigationBarHidden: boolean; message 'isNavigationBarHidden';
    procedure setNavigationBarHidden_animated (hidden: boolean; animated: boolean); message 'setNavigationBarHidden:animated:';
    function navigationBar: UINavigationBar; message 'navigationBar';
    procedure setToolbarHidden(newValue: boolean); message 'setToolbarHidden:';
    function isToolbarHidden: boolean; message 'isToolbarHidden';
    procedure setToolbarHidden_animated (hidden: boolean; animated: boolean); message 'setToolbarHidden:animated:'; { available in 3_0 }
    function toolbar: UIToolbar; message 'toolbar';
    procedure setDelegate(newValue: UINavigationControllerDelegateProtocol); message 'setDelegate:';
    function delegate: UINavigationControllerDelegateProtocol; message 'delegate';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UINavigationControllerDelegateProtocol = objcprotocol external name 'UINavigationControllerDelegate' (NSObjectProtocol)
  optional
    procedure navigationController_willShowViewController_animated (navigationController: UINavigationController; viewController: UIViewController; animated: boolean); message 'navigationController:willShowViewController:animated:';
    procedure navigationController_didShowViewController_animated (navigationController: UINavigationController; viewController: UIViewController; animated: boolean); message 'navigationController:didShowViewController:animated:';
  end;
{$endif}

{$ifdef CLASSES}

type
  UINavigationControllerItem = objccategory external (UIViewController)
    function navigationItem: UINavigationItem; message 'navigationItem';
    procedure setHidesBottomBarWhenPushed(newValue: boolean); message 'setHidesBottomBarWhenPushed:';
    function hidesBottomBarWhenPushed: boolean; message 'hidesBottomBarWhenPushed';
    function navigationController: UINavigationController; message 'navigationController';
  end;

type
  UINavigationControllerContextualToolbarItems = objccategory external (UIViewController)
    procedure setToolbarItems(newValue: NSArray); message 'setToolbarItems:';
    function toolbarItems: NSArray; message 'toolbarItems';
    procedure setToolbarItems_animated (toolbarItems_: NSArray; animated: boolean); message 'setToolbarItems:animated:'; { available in 3_0 }
  end;
{$endif}

