{ Parsed from UIKit.framework (iPhoneOS6.0) UIPopoverController.h }
{ Created on Wed Sep 12 7:28:48 2012 }


{$ifdef TYPES}
type
  UIPopoverControllerPtr = ^UIPopoverController;
  UIPopoverControllerDelegateProtocolPtr = ^UIPopoverControllerDelegateProtocol;
{$endif}

{$ifdef TYPES}
type
  UIPopoverArrowDirection = NSUInteger;
  UIPopoverArrowDirectionPtr = ^UIPopoverArrowDirection;

const
  UIPopoverArrowDirectionUp = 1 shl 0;
  UIPopoverArrowDirectionDown = 1 shl 1;
  UIPopoverArrowDirectionLeft = 1 shl 2;
  UIPopoverArrowDirectionRight = 1 shl 3;
  UIPopoverArrowDirectionAny = UIPopoverArrowDirectionUp + UIPopoverArrowDirectionDown + UIPopoverArrowDirectionLeft + UIPopoverArrowDirectionRight;
  UIPopoverArrowDirectionUnknown = NSUIntegerMax;
{$endif}

{$ifdef CLASSES}

type
  UIPopoverController = objcclass external (NSObject, UIAppearanceContainerProtocol)
  private
  public
    function initWithContentViewController (viewController: UIViewController): id; message 'initWithContentViewController:';
    procedure setDelegate(newValue: UIPopoverControllerDelegateProtocol); message 'setDelegate:';
    function delegate: UIPopoverControllerDelegateProtocol; message 'delegate';
    procedure setContentViewController(newValue: UIViewController); message 'setContentViewController:';
    function contentViewController: UIViewController; message 'contentViewController';
    procedure setContentViewController_animated (viewController: UIViewController; animated: boolean); message 'setContentViewController:animated:';
    procedure setPopoverContentSize(newValue: CGSize); message 'setPopoverContentSize:';
    function popoverContentSize: CGSize; message 'popoverContentSize';
    procedure setPopoverContentSize_animated (size: CGSize; animated: boolean); message 'setPopoverContentSize:animated:';
    function isPopoverVisible: boolean; message 'isPopoverVisible';
    function popoverArrowDirection: UIPopoverArrowDirection; message 'popoverArrowDirection';
    procedure setPassthroughViews(newValue: NSArray); message 'setPassthroughViews:';
    function passthroughViews: NSArray; message 'passthroughViews';
    procedure presentPopoverFromRect_inView_permittedArrowDirections_animated (rect: CGRect; view: UIView; arrowDirections: UIPopoverArrowDirection; animated: boolean); message 'presentPopoverFromRect:inView:permittedArrowDirections:animated:';
    procedure presentPopoverFromBarButtonItem_permittedArrowDirections_animated (item: UIBarButtonItem; arrowDirections: UIPopoverArrowDirection; animated: boolean); message 'presentPopoverFromBarButtonItem:permittedArrowDirections:animated:';
    procedure dismissPopoverAnimated (animated: boolean); message 'dismissPopoverAnimated:';
    procedure setPopoverLayoutMargins(newValue: UIEdgeInsets); message 'setPopoverLayoutMargins:';
    function popoverLayoutMargins: UIEdgeInsets; message 'popoverLayoutMargins';
    procedure setPopoverBackgroundViewClass(newValue: pobjc_class); message 'setPopoverBackgroundViewClass:';
    function popoverBackgroundViewClass: pobjc_class; message 'popoverBackgroundViewClass';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UIPopoverControllerDelegateProtocol = objcprotocol external name 'UIPopoverControllerDelegate' (NSObjectProtocol)
  optional
    function popoverControllerShouldDismissPopover (popoverController: UIPopoverController): boolean; message 'popoverControllerShouldDismissPopover:';
    procedure popoverControllerDidDismissPopover (popoverController: UIPopoverController); message 'popoverControllerDidDismissPopover:';
  end;
{$endif}

{$ifdef CLASSES}

type
  UIViewController_UIPopoverController = objccategory external name 'UIPopoverController' (UIViewController)
    procedure setContentSizeForViewInPopover(newValue: CGSize); message 'setContentSizeForViewInPopover:';
    function contentSizeForViewInPopover: CGSize; message 'contentSizeForViewInPopover';
    procedure setModalInPopover(newValue: boolean); message 'setModalInPopover:';
    function isModalInPopover: boolean; message 'isModalInPopover';
  end;
{$endif}

