{ Parsed from UIKit.framework (iPhoneOS6.0) UIScreen.h }
{ Created on Wed Sep 12 7:28:48 2012 }


{$ifdef TYPES}
type
  UIScreenPtr = ^UIScreen;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  UIScreenDidConnectNotification: NSString { available in 3_2 }; cvar; external;
  UIScreenDidDisconnectNotification: NSString { available in 3_2 }; cvar; external;
  UIScreenModeDidChangeNotification: NSString { available in 3_2 }; cvar; external;
  UIScreenBrightnessDidChangeNotification: NSString { available in 5_0 }; cvar; external;
{$endif}

{$ifdef TYPES}
type
  UIScreenOverscanCompensation = NSInteger;
  UIScreenOverscanCompensationPtr = ^UIScreenOverscanCompensation;

const
  UIScreenOverscanCompensationScale = 0;
  UIScreenOverscanCompensationInsetBounds = 1;
  UIScreenOverscanCompensationInsetApplicationFrame = 2;
{$endif}

{$ifdef CLASSES}

type
  UIScreen = objcclass external (NSObject)
  private
    _display: id;
    _bounds: CGRect;
    _scale: CGFloat;
    _horizontalScale: CGFloat;
    _screenFlags: bitpacked record
      case byte of
        0: (_anonBitField__screenFlags0: cuint);
        1: (
          bitsPerComponent: 0..((1 shl 4)-1);
          initialized: 0..1;
          connected: 0..1;
          overscanCompensation: 0..((1 shl 2)-1);
        );
      end;
  public
    class function screens: NSArray; message 'screens'; { available in 3_2 }
    class function mainScreen: UIScreen; message 'mainScreen';
    function bounds: CGRect; message 'bounds';
    function applicationFrame: CGRect; message 'applicationFrame';
    function scale: CGFloat; message 'scale';
    function availableModes: NSArray; message 'availableModes';
    function preferredMode: UIScreenMode; message 'preferredMode';
    procedure setCurrentMode(newValue: UIScreenMode); message 'setCurrentMode:';
    function currentMode: UIScreenMode; message 'currentMode';
    procedure setOverscanCompensation(newValue: UIScreenOverscanCompensation); message 'setOverscanCompensation:';
    function overscanCompensation: UIScreenOverscanCompensation; message 'overscanCompensation';
    function mirroredScreen: UIScreen; message 'mirroredScreen';
    procedure setBrightness(newValue: CGFloat); message 'setBrightness:';
    function brightness: CGFloat; message 'brightness';
    procedure setWantsSoftwareDimming(newValue: boolean); message 'setWantsSoftwareDimming:';
    function wantsSoftwareDimming: boolean; message 'wantsSoftwareDimming';
    function displayLinkWithTarget_selector (target: id; sel_: SEL): CADisplayLink; message 'displayLinkWithTarget:selector:'; { available in 4_0 }
  end;
{$endif}

