{ Parsed from UIKit.framework (iPhoneOS6.0) UITabBarController.h }
{ Created on Wed Sep 12 7:28:48 2012 }


{$ifdef TYPES}
type
  UITabBarControllerPtr = ^UITabBarController;
  UITabBarControllerDelegateProtocolPtr = ^UITabBarControllerDelegateProtocol;
{$endif}

{$ifdef CLASSES}

type
  UITabBarController = objcclass external (UIViewController, UITabBarDelegateProtocol, NSCodingProtocol)
  private
    _tabBar: UITabBar;
    _containerView: UIView;
    _viewControllerTransitionView: UIView;
    _tabBarItemsToViewControllers: id;
    _selectedViewController: UIViewController;
    _moreNavigationController: UINavigationController;
    _customizableViewControllers: NSArray;
    _delegate: UITabBarControllerDelegateProtocol;
    _selectedViewControllerDuringWillAppear: UIViewController;
    _transientViewController: UIViewController;
    _maxItems: NSUInteger;
    _tabBarControllerFlags: bitpacked record
      case byte of
        0: (_anonBitField__tabBarControllerFlags0: cuint);
        1: (
          isShowingMoreItem: 0..1;
          needsToRebuildItems: 0..1;
          isBarHidden: 0..1;
          editButtonOnLeft: 0..1;
        );
      end;
  public
    procedure setViewControllers(newValue: NSArray); message 'setViewControllers:';
    function viewControllers: NSArray; message 'viewControllers';
    procedure setViewControllers_animated (viewControllers_: NSArray; animated: boolean); message 'setViewControllers:animated:';
    procedure setSelectedViewController(newValue: UIViewController); message 'setSelectedViewController:';
    function selectedViewController: UIViewController; message 'selectedViewController';
    procedure setSelectedIndex(newValue: NSUInteger); message 'setSelectedIndex:';
    function selectedIndex: NSUInteger; message 'selectedIndex';
    function moreNavigationController: UINavigationController; message 'moreNavigationController';
    procedure setCustomizableViewControllers(newValue: NSArray); message 'setCustomizableViewControllers:';
    function customizableViewControllers: NSArray; message 'customizableViewControllers';
    function tabBar: UITabBar; message 'tabBar';
    procedure setDelegate(newValue: UITabBarControllerDelegateProtocol); message 'setDelegate:';
    function delegate: UITabBarControllerDelegateProtocol; message 'delegate';

    { Adopted protocols }
    procedure tabBar_didBeginCustomizingItems (tabBar: UITabBar; items: NSArray); message 'tabBar:didBeginCustomizingItems:';
    procedure tabBar_didEndCustomizingItems_changed (tabBar: UITabBar; items: NSArray; changed: boolean); message 'tabBar:didEndCustomizingItems:changed:';
    procedure tabBar_didSelectItem (tabBar: UITabBar; item: UITabBarItem); message 'tabBar:didSelectItem:';
    procedure tabBar_willBeginCustomizingItems (tabBar: UITabBar; items: NSArray); message 'tabBar:willBeginCustomizingItems:';
    procedure tabBar_willEndCustomizingItems_changed (tabBar: UITabBar; items: NSArray; changed: boolean); message 'tabBar:willEndCustomizingItems:changed:';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  UITabBarControllerDelegateProtocol = objcprotocol external name 'UITabBarControllerDelegate' (NSObjectProtocol)
  optional
    function tabBarController_shouldSelectViewController (tabBarController: UITabBarController; viewController: UIViewController): boolean; message 'tabBarController:shouldSelectViewController:'; { available in 3_0 }
    procedure tabBarController_didSelectViewController (tabBarController: UITabBarController; viewController: UIViewController); message 'tabBarController:didSelectViewController:';
    procedure tabBarController_willBeginCustomizingViewControllers (tabBarController: UITabBarController; viewControllers: NSArray); message 'tabBarController:willBeginCustomizingViewControllers:'; { available in 3_0 }
    procedure tabBarController_willEndCustomizingViewControllers_changed (tabBarController: UITabBarController; viewControllers: NSArray; changed: boolean); message 'tabBarController:willEndCustomizingViewControllers:changed:'; { available in 3_0 }
    procedure tabBarController_didEndCustomizingViewControllers_changed (tabBarController: UITabBarController; viewControllers: NSArray; changed: boolean); message 'tabBarController:didEndCustomizingViewControllers:changed:';
  end;
{$endif}

{$ifdef CLASSES}

type
  UITabBarControllerItem = objccategory external (UIViewController)
    procedure setTabBarItem(newValue: UITabBarItem); message 'setTabBarItem:';
    function tabBarItem: UITabBarItem; message 'tabBarItem';
    function tabBarController: UITabBarController; message 'tabBarController';
  end;
{$endif}

