{ Parsed from UIKit.framework (iPhoneOS6.0) UIToolbar.h }
{ Created on Wed Sep 12 7:28:48 2012 }


{$ifdef TYPES}
type
  UIToolbarPtr = ^UIToolbar;
{$endif}

{$ifdef TYPES}
type
  UIToolbarPosition = NSInteger;
  UIToolbarPositionPtr = ^UIToolbarPosition;

const
  UIToolbarPositionAny = 0;
  UIToolbarPositionBottom = 1;
  UIToolbarPositionTop = 2;
{$endif}

{$ifdef CLASSES}

type
  UIToolbar = objcclass external (UIView)
  private
    _delegate: id;
    _items: NSArray;
    _tintColor: UIColor;
    _toolbarFlags: bitpacked record
      case byte of
        0: (_anonBitField__toolbarFlags0: cuint);
        1: (
          barStyle: 0..((1 shl 2)-1);
          mode: 0..((1 shl 2)-1);
          wasEnabled: 0..1;
          downButtonSentAction: 0..1;
          isTranslucent: 0..1;
          forceTopBarAppearance: 0..1;
          autolayoutIsLocked: 0..1;
        );
      end;
    _groups: CFMutableDictionaryRef;
    _buttonItems: NSArray;
    _currentButtonGroup: NSInteger;
    _pressedTag: NSInteger;
    _extraEdgeInsets: CGFloat;
    _backgroundView: UIView;
    _appearanceStorage: id;
    _currentAlert: id;
  public
    procedure setBarStyle(newValue: UIBarStyle); message 'setBarStyle:';
    function barStyle: UIBarStyle; message 'barStyle';
    procedure setItems(newValue: NSArray); message 'setItems:';
    function items: NSArray; message 'items';
    procedure setTranslucent(newValue: boolean); message 'setTranslucent:';
    function isTranslucent: boolean; message 'isTranslucent';
    procedure setItems_animated (items_: NSArray; animated: boolean); message 'setItems:animated:';
    procedure setTintColor(newValue: UIColor); message 'setTintColor:';
    function tintColor: UIColor; message 'tintColor';
    procedure setBackgroundImage_forToolbarPosition_barMetrics (backgroundImage: UIImage; topOrBottom: UIToolbarPosition; barMetrics: UIBarMetrics); message 'setBackgroundImage:forToolbarPosition:barMetrics:'; { available in 5_0 }
    function backgroundImageForToolbarPosition_barMetrics (topOrBottom: UIToolbarPosition; barMetrics: UIBarMetrics): UIImage; message 'backgroundImageForToolbarPosition:barMetrics:'; { available in 5_0 }
    procedure setShadowImage_forToolbarPosition (shadowImage: UIImage; topOrBottom: UIToolbarPosition); message 'setShadowImage:forToolbarPosition:'; { available in 6_0 }
    function shadowImageForToolbarPosition (topOrBottom: UIToolbarPosition): UIImage; message 'shadowImageForToolbarPosition:'; { available in 6_0 }
  end;
{$endif}

